/* $Id: dbfm.js,v 1.3.2.101 2010/06/02 16:56:14 geoffeagles Exp $ */

/** 
 * the dbfm hover (DH) is an adaption of a jtip that I found on Cody Lindley's site codylindley.com
 * I had different needs - his box flipped from left to right depending on how close it was to the screen edges - I didn't need that
 * however it didn't flip up as it got too close to the bottom and his code didn't allow for the screen being scrolled
 * either HOWEVER Cody now recommends Karl Swedberg's cluetip which is SO much better and will probably do everything you could ever want!
 * see http://plugins.learningjquery.com/cluetip/demo/
 * I won't be using cluetip however - I only need a tiny fraction of the functionality
 * parameters are the url that's going to populate our box and a flag to indicate whether the box contains an image - this effects the position of the box
 * because images take more room.
 * positioning of the tooltips proved a pain. You don't know the size of what you're displaying until you display it (because you're loading it from a url).
 * I tried measuring it then re-adjusting the top BUT the height was always reported as 28?? so I've taken average measurements for height and based my 
 * positioning on those 
 */
function DH_show(url, isImage){ 
  //make sure that the delay ID is reset to zero 
  dbFM.delayID = 0; 
  
  //don't show anything if we're already dragging something 
  if (dbFM.dragging) {
    return;
  }  
  $("body").append("<div id='DH' style='width:300px'><div id='DH_copy'><div class='DH_loader'><div></div></div>");
  
  //use the mouse event position to determine where we display the hover-box 
  //sorry about the magic numbers but you need these offsets otherwise you get a sorta jitter
  var posx = dbFM.hEvent.x + 11;
  var posy = dbFM.hEvent.y - 3;

  //now, while the x position is straightforward, the y position has to be adjusted where the box would be too close to the bottom
  var cH = document.body.clientHeight;   //does this work consistently in every browser?
  var theRatio = getConRatio();   //the ratio is set on the dbfm admin screen, the function is in dbfm.module
  var sRatio = posy/cH;
  //add a bit on (imagine we're lower down the screen) if this is an image file
  if (isImage) {
    sRatio = sRatio + 0.1;
  }
  //test whether we're in a popup (dbFM.cContent = true) or this is the main dbFM screen
  if (dbFM.cContent) {
    if (sRatio > theRatio) {
      //need to flip it - I tried to set the bottom but got some strange effects so instead we'll do a little calculation to raise all
      //menus to a certain height
      var fiddle = sRatio - (theRatio);
      if (isImage) {
	    fiddle = fiddle + 0.1;
	  }
      var posy = posy -(fiddle * cH);
    }
  }
  else {
    //we're in the main window. We don't know the height of a tooltip before we launch it so we're going to guess - at 100 for a standard tooltip and 180 for an
    //image tooltip. We just adjust the y position to allow that much room
    var theViewport = $(window).height();
    if (isImage) {
      if ((theViewport - posy) < 270) {
	    posy = theViewport - 270;
	  }
	}  
	else if ((theViewport - posy) < 170) {
      posy = theViewport - 170;
	}
  } 
  //show the tip and shove the stuff pointed to by the url into it	
  $('#DH').css({left: posx+"px", top: posy+"px"});
  $('#DH').show();
  $('#DH_copy').load(url);  
}


/* namespace */
function dbFM() {}

/*
** Global variables
*/

// work to do - the browser window itself should be virtually the same now whether it's the main browser 
// window of the one that you call from the node screen. The ONLY difference should be the context 
// menus - so we needn't have 2 sets of code - lets simplify things. ZZZZZZZZZZ

//Translation possible by changing the array values (DO NOT ALTER KEYS!)
dbFM.js_msg = [];
dbFM.js_msg["mkdir"] = "Create new directory";
dbFM.js_msg["file"] = "file";
dbFM.js_msg["directory"] = "directory";
dbFM.js_msg["home"] = "Home";
dbFM.js_msg["version"] = "version directory";
dbFM.js_msg["work"] = "Working...";
dbFM.js_msg["refresh"] = "Refresh";
dbFM.js_msg["sort"] = "Sort by this column";
dbFM.js_msg["column1"] = "Name";
dbFM.js_msg["attach-title"] = "Attached Files";
dbFM.js_msg["column2"] = "Modified";
dbFM.js_msg["column3"] = "Size";
dbFM.js_msg["ajax-err"] = "Server is unreachable";
dbFM.js_msg["mkdir-err"] = "Directory creation fail";
dbFM.js_msg["move-err"] = "Move operation fail";
dbFM.js_msg["getmeta-err"] = "Get properties fail";
dbFM.js_msg["sendmeta-err"] = "Submit properties fail";
dbFM.js_msg["len-err"] = "Too long";
dbFM.js_msg["confirm-det"] = "Do you want to detach ";
dbFM.js_msg["confirm-dbrem0"] = "Do you want to remove ";
dbFM.js_msg["confirm-dbrem1"] = " from the database?\n     All properties and attachments for this file will be lost";

dbFM.menu_msg = [];
dbFM.menu_msg["rendir"] = "Rename directory";
dbFM.menu_msg["mkdir"] = "Create subdirectory";
dbFM.menu_msg["rmdir"] = "Delete directory";
dbFM.menu_msg["srchdir"] = "Search directory";
dbFM.menu_msg["rm"] = "Delete file";
dbFM.menu_msg["ren"] = "Rename file";
dbFM.menu_msg["dmeta"] = "Directory properties";
dbFM.menu_msg["meta"] = "File properties";
dbFM.menu_msg["vmeta"] = "Revision properties";
dbFM.menu_msg["vadd"] = "Upload revision";
dbFM.menu_msg["vren"] = "Rename revision";
dbFM.menu_msg["vdel"] = "Delete all revisions";
dbFM.menu_msg["vdown"] = "Download current revision";
dbFM.menu_msg["vopen"] = "Show revision contents";
dbFM.menu_msg["vnew"] = "Convert to revision";  
dbFM.menu_msg["link"] = "Create link";    
dbFM.menu_msg["linkdir"] = "Link node to directory";    
dbFM.menu_msg["sub"] = "Subscribe";    
dbFM.menu_msg["unsub"] = "Unsubscribe";    

dbFM.menu_msg["emb"] = "Embed image";
dbFM.menu_msg["dwnld"] = "Download file";
dbFM.menu_msg["dwnlddir"] = "Download directory archive"; // new menu option - allows a directory to be downloaded as an archive

//not sure how were're doing the ordering of attachments - do we go for drag and drop or should we have a menu option to promote or demote entries?
dbFM.menu_msg["attach"] = "Attach File to node";    // adds file to attachments list for node
//menu options for new attachment list
dbFM.menu_msg["unattach"] = "Detach file from node"; // new menu option - removes a file from the attachment list
dbFM.menu_msg["attachprop"] = "File properties"; // new menu option - displays a file properties popup for node attachments

//Do not translate any code below this line

//current is used to keep track of the path of the current directory and cfid the fid of the current directory
//it's now changed to be an array
dbFM.current = [];
dbFM.oldOnContextMenu = null;
dbFM.oldOnMouseDown = null;
dbFM.contextMenuDiv = null;
dbFM.eventListeners = [];

dbFM.browser = null;
dbFM.menu = null;
dbFM.dirTreeObj = null;
dbFM.dirListObj = null;
dbFM.attachObj = null;
dbFM.contextMenuObj = null;
dbFM.leftSpaceObj = null;
dbFM.rightSpaceObj = null;
dbFM.filetitle = ' ';
dbFM.verdir = false;
dbFM.verflag = false;  //used to prevent 2 mouse events

dbFM.ListY = 0;
dbFM.TreeY = 0;

//should these offsets be variables? - why not hard code? - ah we need global variables rather than passing them
dbFM.scrollOffsetX = 0;
dbFM.scrollOffsetY = 0;

dbFM.offsetX=16; // Offset X away from mouse
dbFM.offsetY=16; // Offset Y
dbFM.popUp = false; // Is a popup active - used to stop the context callback function running

dbFM.renameActive = null;   //used mainly by the menus

dbFM.dragCont = null;
dbFM.dragStart = null;
dbFM.dragging = false;
dbFM.activeCont = null;
dbFM.dropContainers = [];
dbFM.attachContainer = [];
dbFM.attachFlag = false;
dbFM.zindex = 10000;

//these 'globals' are used to deal with the tooltip delay.
dbFM.delayID = 0;   //this is used to store the ID of the delay used to ensure that the user really wants the Tooltip to be displayed
dbFM.newurl = '';
dbFM.clickObj = '';
dbFM.hEvent = null;  //the hover mouse event - needed to get the mouse position

dbFM.dlistID = 'dirlist';   //holds the name (ID) of the directory listing because it now varies with browser
dbFM.cContent = false;   //a flag to indicate that dbfm is being used within a popup window (when creating content). Needed to truncate filenames
dbFM.tooltips = true;    //a flag used to stop tooltips displaying while a context menu is active or when renaming etc.
dbFM.conTimeOut = 0;     //a timeout used to prevent the context menu from just hanging about without anything selected
dbFM.celement = null;    //a global containing the current element

//Name of node edit form hidden field where attached node list is populated by js DO WE NEED THIS? surely it's hard coded??
//dbFM.attachFormInput = "edit-attachedfiles";
dbFM.attachFormInput = "edit-attachlist";

/*
** Functions to draw the dbfm browser
*/

if (Drupal.jsEnabled) {
  $(window).load(dbfmLayout);             //draws the main browser ONLY if it can find the 'dbfm' element in the html
  $(window).load(dbfmAttachPopupLayout);  //creates this ONLY if it finds the 'dbfm-popup' element in the html (we must be on the node form)
  $(window).load(dbfmdragContainer);      //creates the drag and drop container
  $(window).load(dbfmcontextContainer);   //creates a container for the context menu
}

/**
 * Determine browser - arghh, we now need to differentiate between Safari Windows and Safari Mac
 */
dbFM.browserDetect = function() {
  this.isSafari = false;
  this.isIE = false;
  this.OS = "windows"; 
  
  var b = navigator.userAgent.toLowerCase();
  if (b.indexOf("msie") >= 0) {
    this.isIE = true;
  }
  if (b.indexOf("safari") >= 0) {
    this.isSafari = true;
  }
  if (b.indexOf("linux") >= 0) {
    this.OS = "linux";
  }
  else if (b.indexOf("macintosh") >= 0) {
    this.OS = "macintosh";
  }

}

/**
 * Hashable Hashtable (used by menus) - this is quite a flexible system taken from webFM which can 
 * allow external functions to create menu entries
 */
dbFM.hht = function() {
  this.flush();
}

dbFM.hht.prototype.put = function(key, obj) {
  if((key == null) || (obj == null))
    throw "NullPointerException {" + key + "},{" + obj + "}";

  if(this.hash[key] == null) {
    this.keys[this.keys.length] = key;
    this.hash[key] = new Array();
 }

  // append new object to array
  this.hash[key].push(obj);
}

dbFM.hht.prototype.get = function(key) {
  return this.hash[key];
}

dbFM.hht.prototype.remove = function(key) {
  if(this.hash[key]) {
    this.hash[key] = null;
    return true;
  }
  return false;
}

dbFM.hht.prototype.removeSub = function(key, subkey) {
  if(this.hash[key][subkey]) {
    this.hash[key][subkey] = null;
    return true;
  }
  return false;
}

dbFM.hht.prototype.flush = function() {
  this.hash = new Array();
  this.keys = new Array();
}
/* end of hash table stuff */

/**
 * Create dbFM Manager at 'dbfm' id anchor. This is the main dbFM browser, as opposed to the browser 
 * loaded from the node / textareas when embedding / linking
 */
 
function dbfmLayout() {
  var layoutDiv = '';

  //does a 'get element by id' to find what we're pointing at
  layoutDiv = dbFM.$('dbfm');

  if (layoutDiv) {
    //checks what browser they're running
    dbFM.browser = new dbFM.browserDetect();

    //menu table is global to allow external functions to push new menu elements
    //into the menu array
    dbFM.menu = new dbFM.hht();
    try {
      dbFM.menu.put('root', new dbFM.menuElement(dbFM.menu_msg["mkdir"], dbFM.menuMkdir, ''));
      dbFM.menu.put('root', new dbFM.menuElement(dbFM.menu_msg["dwnlddir"], dbFM.menuDownload, ''));
      
      dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["mkdir"], dbFM.menuMkdir, ''));
      dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["rmdir"], dbFM.menuRemove, ''));
      //the search window should ideally only be available only where there are files and directories below the directory selected.
      //we currently have no way to determine this in the JS so the search screen will be shown whatever
      dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["srchdir"], dbFM.menuFSearch, ''));
      
      //rename function has been removed for the directory tree
      dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["rendir"], dbFM.menuRename, dbfmTreeTest));
      //added properties for directories - note that a function is used to check whether to show this option
      dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["dmeta"], dbFM.menuGetMeta, dbfmTreeTest));
      dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["dwnlddir"], dbFM.menuDownload, ''));

      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["rm"], dbFM.menuRemove, ''));
      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["ren"], dbFM.menuRename, dbfmVerTest));
      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["meta"], dbFM.menuGetMeta));

      //new file menu option - allows them to change an existing file into a version directory with one file in it
      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["vnew"], dbFM.menuVersion, dbfmVerTest));
      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["dwnld"], dbFM.menuDownload));
      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["sub"], dbFM.menuSub, dbfmTestSub));
      dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["unsub"], dbFM.menuSub, dbfmTestUnSub));

      //new options for version directories - the files below them have normal file attributes
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vadd"], dbFM.menuVUpload));  //upload new file
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vren"], dbFM.menuRename));  //rename the version direcory      
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vmeta"], dbFM.menuGetMeta));  //version properties
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vdel"], dbFM.menuVDel));  //delete the version directory
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vdown"], dbFM.menuDownload));  //download the current version
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vopen"], dbFM.menuVOpen));  //open the version directory
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["sub"], dbFM.menuSub, dbfmTestSub));
      dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["unsub"], dbFM.menuSub, dbfmTestUnSub));

   } 
    catch(err) {
      alert("Menu Create err\n" + err);
    }

    var layout_cont = dbFM.ce('div');
    var elTreeDiv = dbFM.ce('div');
    elTreeDiv.setAttribute('id', 'tree'); //css id
    layout_cont.appendChild(elTreeDiv);
    dbFM.dirTreeObj = new dbFM.tree(elTreeDiv, 'dirtree', 'Directory', 'readtree', dbFM.menu.get('root'), dbFM.menu.get('dir'));

    //test which browser they're using, we give the directory listing a different id (so that the css can be different) if they're using IE or Safari
    if(dbFM.browser.isIE ) {
      dbFM.dlistID = 'iedirlist';
    }
    else if (dbFM.browser.isSafari) {
      dbFM.dlistID = 'sfdirlist';
      dbFM.leftSpaceObj = new dbFM.spacer(layout_cont,'leftSpace');
      dbFM.rightSpaceObj = new dbFM.spacer(layout_cont,'rightSpace');
    }
	else {
	  dbFM.dlistID = 'dirlist';
      dbFM.leftSpaceObj = new dbFM.spacer(layout_cont,'leftSpace');
      dbFM.rightSpaceObj = new dbFM.spacer(layout_cont,'rightSpace');
	}	
	dbFM.dirListObj = new dbFM.list(layout_cont, dbFM.dlistID, 'file', true, 'narrow', true, dbFM.menu.get('dir'), dbFM.menu.get('ver'), dbFM.menu.get('file'), true);

    //insert trees, listing, search, etc. before upload fset
    layoutDiv.insertBefore(layout_cont, layoutDiv.firstChild);

    //create the persistent context menu object
    dbFM.contextMenuObj = new dbFM.context();

    dbFM.dirTreeObj.fetch(true);
    dbFM.dirListObj.fetch(1);
    dbfm_browser_ref(true);

    //it's not necessary to do this in the popup window 
    if(dbFM.browser.isIE ) {
      //use jquery to put corners on the directory listing - because of the background we use at eserv spacers look better for us. However in IE whenever you
      //reduce the screensize the directory listing moves lower down the page. Tried fixing the problem with spans - and failed. 
      $('.narrow').corner();
    }
  }
}

 
//set a flag - because we have limited space in the popup and so we need to truncate the filename more
function dbfmAttachPopupLayout () {

  var layoutDiv = '';
  layoutDiv = dbFM.$('dbfm-popup');
  if(layoutDiv) {
    dbFM.cContent = true;
    dbfmEscape();
    dbfmLayoutFunc(layoutDiv);
  }
  //add the code to allow attachments but ONLY if attachments are enabled (there will be no edit-attachlist element if they're not enabled
  var attachDiv = '';
  attachDiv = dbFM.$('dbfm-attach');
  if (attachDiv) {
    dbFM.attachFlag = true;  //set a flag to indicate that we're using attachments
    dbFM.browser = new dbFM.browserDetect();

    dbFM.menu = new dbFM.hht();
    try {
      //menu options for attachments
      dbFM.menu.put('att', new dbFM.menuElement(dbFM.menu_msg["unattach"], dbFM.menuDetach));  //delete a file from the attachment list
      dbFM.menu.put('att', new dbFM.menuElement(dbFM.menu_msg["attachprop"], dbFM.menuGetMeta));  //open the properties window
    } 
    catch(err) {
      alert("Attach Menu Create error\n" + err);
    }
    //this code (to fill the list of attachments) cannot work unless some js has previosly been loaded onto the page
    dbFM.attachObj = new dbFM.attach('dbfm-attach');
    dbFM.attachObj.fetch();
    
    //create the persistent context menu object
    dbFM.contextMenuObj = new dbFM.context();

  }
}

// this is the browser that appears in the popup - it has the facilities we have in the full browser and additionally the users can 
// link and embed files + attach too
function dbfmLayoutFunc(layoutDiv) {
  //has to go here the constructor didn't work when I moved it up into the global area
  dbFM.browser = new dbFM.browserDetect();

  //create the context menu elements
  dbFM.menu = new dbFM.hht();
  try {
    dbFM.menu.put('root', new dbFM.menuElement(dbFM.menu_msg["mkdir"], dbFM.menuMkdir, ''));

    dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["mkdir"], dbFM.menuMkdir, ''));
    dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["rmdir"], dbFM.menuRemove, ''));
    //the search window should ideally only be available only where there are files and directories below the directory selected.
    //we currently have no way to determine this in the JS so the search screen will be shown whatever
    dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["srchdir"], dbFM.menuFSearch, ''));

    //rename function has been removed for the directory tree
    dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["rendir"], dbFM.menuRename, dbfmTreeTest));
    //added properties for directories - note that a function is used to check whether to show this option
    dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["dmeta"], dbFM.menuGetMeta, dbfmTreeTest));
    dbFM.menu.put('dir', new dbFM.menuElement(dbFM.menu_msg["linkdir"], dbFM.menuLinkDir, dbfmTreeTest));

    //new options for version directories - the files below them have normal file attributes
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vadd"], dbFM.menuVUpload));  //upload new file
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vren"], dbFM.menuRename));  //rename version directory
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vmeta"], dbFM.menuGetMeta));  //version properties
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vdel"], dbFM.menuVDel));  //delete the version directory
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vdown"], dbFM.menuDownload));  //download the current version
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["vopen"], dbFM.menuVOpen));  //open the version directory
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["link"], dbFM.menuLink));
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["emb"], dbFM.menuEmbed, dbfmImagesTest));
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["attach"], dbFM.menuAttach, getAttach));
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["sub"], dbFM.menuSub, dbfmTestSub));
    dbFM.menu.put('ver', new dbFM.menuElement(dbFM.menu_msg["unsub"], dbFM.menuSub, dbfmTestUnSub));

    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["link"], dbFM.menuLink));
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["attach"], dbFM.menuAttach, getAttach));
    //added a test to see whether it's an image file before embedding
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["emb"], dbFM.menuEmbed, dbfmImagesTest));
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["rm"], dbFM.menuRemove, ''));
    //rename has been taken out - replaced - due to the confusion (generated by Charly over filenames and filetitles
    //if the file is within a version directory then don't allow it to be renamed (VerTest checks)
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["ren"], dbFM.menuRename, dbfmVerTest));
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["meta"], dbFM.menuGetMeta));
    //new file menu option - allows them to change an existing file into a version directory with one file in it
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["vnew"], dbFM.menuVersion, dbfmVerTest));
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["dwnld"], dbFM.menuDownload));
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["sub"], dbFM.menuSub, dbfmTestSub));
    dbFM.menu.put('file', new dbFM.menuElement(dbFM.menu_msg["unsub"], dbFM.menuSub, dbfmTestUnSub));

  } catch(err) {
    alert("Error Creating Menus\n" + err);
  }

  var layout_cont = dbFM.ce('div');
  var elTreeDiv = dbFM.ce('div');
  elTreeDiv.setAttribute('id', 'tree'); //css id
  layout_cont.appendChild(elTreeDiv);

  dbFM.dirTreeObj = new dbFM.tree(elTreeDiv, 'dirtree', 'Directory', 'readtree', dbFM.menu.get('root'), dbFM.menu.get('dir'));
  dbFM.leftSpaceObj = new dbFM.spacer(layout_cont,'leftSpace');
  dbFM.rightSpaceObj = new dbFM.spacer(layout_cont,'rightSpace');
  
  if(dbFM.browser.isIE) {
    dbFM.dlistID = 'iedirlist';
  }
  else if(dbFM.browser.isSafari) {
    dbFM.dlistID = 'sfdirlist';
  }
  else {
    dbFM.dlistID = 'dirlist';
  }
  
  dbFM.dirListObj = new dbFM.list(layout_cont, dbFM.dlistID, 'node', true, 'narrow', true, dbFM.menu.get('dir'), dbFM.menu.get('ver'), dbFM.menu.get('file'), false);

  layoutDiv.insertBefore(layout_cont, layoutDiv.firstChild);

  dbFM.contextMenuObj = new dbFM.context();

  dbFM.dirTreeObj.fetch(true);
  dbFM.dirListObj.fetch(1);
  dbfm_browser_ref(true);
}

//introduced to limit the context menus appearing for attachments - obj is the selected element
function dbfmImageTestExtra(obj) {
  var elDivdbFM;
  //tests whether we're on the popup screen
  if (elDivdbFM = dbFM.$('dbfm-inline')) {
    return false;
  }
  else {
    return dbfmImagesTest(obj);
  }
}

// calls dbfmITest with the file extension.
function dbfmImagesTest(obj) {
  return dbfmITest(obj.ext.toLowerCase());
}

//dbfmITest is passed the lowercase filename extension
//note - there is a problem with a tiff image - being a proprietary format you need a plugin to display it
function dbfmITest(fext) {

  var imgextns = new Array("jpg","jpeg","gif","png","bmp","tif","tiff");
  for (i = 0; i < imgextns.length; i++) {  
    if (imgextns[i] == fext) {  
      return true;  
    }  
  } 
  return false;   
}

// disable the properties menu if called from the directory tree (rather than the file browser
dbfmTreeTest = function(obj){
  //should be able to test and see whether it's a tree
  if (obj.element.className.substring(0,4) != 'tree') return true;
  return false;
}

//test to see whether we should display the 'susbcribe' menu option
dbfmTestSub = function(obj) {
  //test first whether subs are supported
  if (dbfmSubTest()) {
    //now test whether or not the object is already subscribed
    if (!obj.sub)
      return true;
  }
  return false;
}
//test to see whether we should display the 'Unsusbcribe' menu option
dbfmTestUnSub = function(obj) {
  //test first whether subs are supported
  if (dbfmSubTest()) {
    //now test whether or not the object is already subscribed
    if (obj.sub)
      return true;
  }
  return false;
}


// allows or disallows menu options depending on whether or not this is a version directory
dbfmVerTest = function(obj){
  if (dbFM.verdir == true) {
    return false;
  }
  return true;
}

//not sure I need this - what is obj??
dbfmImagesResize = function(obj){
  var url = dbFM.ajaxUrl();
  var path = obj.element.title;
  var postObj = { action:this.desc, filepath:encodeURIComponent(path)};
  dbFM.HTTPPost(url, dbfmImageResizeResult, obj, postObj);
  return false;
}
//not sure I need this?
dbfmImageResizeResult = function(response){
  dbFM.dirListObj.refresh(); //im guessing they need the current directory here?
//  dbFM.alrtObj.msg();
  alert(response);
}

// Create the drag container that will show the item while dragging
function dbfmdragContainer() {
  dbFM.dragCont = dbFM.ce('div');
  dbFM.dragCont.setAttribute('id','dragCont'); //id for css
  dbFM.dragCont.style.cssText = 'position:absolute;display:none;';
  document.body.appendChild(dbFM.dragCont);
}

function dbfmEscape() {
  //function to catch the escape key
  document.onkeypress=function(e){
    var e = window.event || e;
    if (e.keyCode == 27 || e.which == 27){
      parent.GB_hide();
	}
  }
}

function dbfmcontextContainer() {
  // Create the context menu container that will display the menu
  dbFM.oldOnContextMenu = document.body.oncontextmenu;
  dbFM.oldOnMouseDown = document.onmousedown;
  dbFM.contextMenuDiv = dbFM.ce('div');
  dbFM.contextMenuDiv.setAttribute('id', 'cxtCont');  //id for css
  dbFM.contextMenuDiv.style.cssText = 'position:absolute;display:none;';
  document.body.appendChild(dbFM.contextMenuDiv);
}


/**
 * dbFM.list constructor
 *
 * 2nd param is base id of listing (multiple listing objects must have unique ids)
 * 3rd param is base id of file rows of table
 * 4th param is flag to determine if table head has the 'Create New Dir' button
 * 5th param sets styling for listing
 * 6th param enables drag and drop
 * 7th param is directory menu array
 * 8th param is version menu array
 * 9th param is file menu array
 * 10th param is a flag to indicate whether this is the main browser window or a popup window
 *
 * Big changes here from how webFM used to do it. Instead of one table there are now 2. The top table merely holds the refresh icon, the 
 * breadcrumb and the icons for 'search', 'help' etc.
 * the second table starts with the columnheaders. The layout of the whole table is based on the fixed dimensions of the headers. Aparently this 
 * has the advantage of allowing the table to load faster (and it makes it FAR easier for me to align things with the top table.
 */
dbFM.list = function(parent, id, type, mkdir_flag, class_name, dd_enable, dir_menu, ver_menu, file_menu, is_main ) {
  var wl = this;
  this.id = id;
  this.type = type;
  this.dd_enable = dd_enable;
  this.dir_cxt_en = mkdir_flag; //if no create dir button, assume no dir cxt menu
  this.url = dbFM.ajaxUrl();
  this.sc_n = 0;
  this.sc_m = 0;
  this.sc_s = 0;
  this.content = '';
  this.iconDir = getIconDir();
  this.dir_menu = dir_menu;
  this.ver_menu = ver_menu;
  this.file_menu = file_menu;

  var node = dbFM.ce('div');
  node.setAttribute('id', this.id);
  node.className = class_name;

  //add a table just for the top header stuff - the refresh icon, breadcrumb etc. etc.
  var elHTable = dbFM.ce('table');
  elHTable.setAttribute('id', this.id + 'ttable'); 
  var elHTableBody = dbFM.ce('tbody');
  elHTableBody.setAttribute('id', this.id + 'headbody');  

  // First (and only) Table Row (tr) in the first (top header) table
  var elTr = dbFM.ce('tr');
  elTr.setAttribute('id', this.id + 'firstrow');

  // Refresh Icon
  var elTd = dbFM.ce('td');
  elTd.className = 'tophead';
  elTd.setAttribute('width','7%');
  
  var elA = dbFM.ce('a');
  elA.setAttribute('href', '#');
  elA.setAttribute('title', dbFM.js_msg["refresh"]);
  var elImg = dbFM.ce('img');
  elImg.setAttribute('src', this.iconDir+ '/r.gif');
  elImg.setAttribute('alt', dbFM.js_msg["refresh"]);
  elImg.setAttribute('id', 'refreshiconlist');
  elA.appendChild(elImg);
  elTd.appendChild(elA);
  elTr.appendChild(elTd);          //make this a child of the first row
  //current[0] is path current[1] is fid
  var listener = dbFM.addEventListener(elA, "click", function(e) { wl.refresh(dbFM.current[1]);dbFM.stopEvent(e); });

  // Breadcrumb trail
  var elTd = dbFM.ce('td');
  //elTd.colSpan = (mkdir_flag === true) ? 2 : 3;  no longer needed since we're setting the colummn widths
  elTd.setAttribute('class','tophead');
  elTd.setAttribute('width','75%');
  // Build breadcrumb trail inside span
  var elSpan = dbFM.ce('span');
  elSpan.setAttribute('id', this.id + 'bcrumb');
//  elSpan.setAttribute('text-align', 'right');

  elTd.appendChild(elSpan);
  elTr.appendChild(elTd);

  // the mkdir flag is ALWAYS set to true at the moment - maybe he planned to do something fancy in the future
  if(mkdir_flag === true) {
  // Create New Directory and allow db insertions
    var elTd = dbFM.ce('td');
    elTd.setAttribute('width','18%');
    var elSpan = dbFM.ce('span');
    elSpan.id = 'buttons';

    var elA = dbFM.ce('a');
    elA.setAttribute('id', 'Search');
    elA.title = "Search Window";
    var elImg = dbFM.ce('img');
    elImg.setAttribute('alt', "Search");
    elImg.setAttribute('src', this.iconDir + '/folder_explore.png');
    elA.appendChild(elImg);

    var listener = dbFM.addEventListener(elA, "click", function() { GB_show('Directory Search - ', getBaseUrl() + '/dbfm_fnsearch/' + dbFM.current[1], 480, 640, 0);});

    elSpan.appendChild(elA);

    var elA = dbFM.ce('a');
    elA.setAttribute('id', 'mdIcon');
    elA.title = "Create new folder";
    var elImg = dbFM.ce('img');
    elImg.setAttribute('alt', "New Folder");
    elImg.setAttribute('id', 'mkdirIcon');
    elImg.setAttribute('src', this.iconDir + '/folder_add.png');
    elA.appendChild(elImg);

    //doesn't allow you to create new folders within a version directory
    var listener = dbFM.addEventListener(elA, "click", function(e) { if (!dbFM.verdir) {dbFM.stopEvent(e); wl.mkdir(e); }});
    var listener = dbFM.addEventListener(elA, "mouseover", function() { this.className = 'button-selected'; });
    var listener = dbFM.addEventListener(elA, "mouseout", function() { this.className = ''; });
    elSpan.appendChild(elA);

    var elA = dbFM.ce('a');
    elA.setAttribute('id', 'upIcon');
    elA.title = "Upload file to filesystem";
    var elImg = dbFM.ce('img');
    elImg.setAttribute('alt', "Upload file to filesystem");
    elImg.setAttribute('id', 'uploadIcon');
    elImg.setAttribute('src', this.iconDir + '/folder_page_white.png');
    elA.appendChild(elImg);
    //parameters are url, height and width
    var listener = dbFM.addEventListener(elA, "click", function() { if (!dbFM.verdir) GB_show('File Manager: Upload File',getBaseUrl() + '/dbfm_uploadit',448,640,1); });
    var listener = dbFM.addEventListener(elA, "mouseover", function() { this.className = 'button-selected'; });
    var listener = dbFM.addEventListener(elA, "mouseout", function() { this.className = ''; });
    elSpan.appendChild(elA);

    var elA = dbFM.ce('a');
    elA.title = "Help";
    var elImg = dbFM.ce('img');
    elImg.setAttribute('alt', "Help");
    elImg.setAttribute('src', this.iconDir + '/hlp.gif');
    elA.appendChild(elImg);
    //function added to return the path for the help - we might want to make it a user configurable variable like icons????
    // then they could subsitute their own help files
    
    //We don't use the greybox for help - just a popup
    //we need to centre the popup - find the client's screen dimensions and do a bit of maths
    var h = self.innerHeight || document.body.clientHeight;
    var w = self.innerWidth || document.body.clientWidth;
    var mh = document.body.clientLeft;

    //we're aiming for a screen size of 900 by 500 so work out the offsets to achieve this
    var topo = (h - 500) / 2;
    var lefto = (w - 900) / 2;
    
    //open a new popup window. parameters are location, title, and attibutes (height, width, resizable etc) - FUCK and buggeration, half a day wasted trying 
	//to find out why this didn't work in IE. Only to find that you're not allowed a space in the name field
    var listener = dbFM.addEventListener(elA, "click", function() { window.open( getDbfmPath() + '/webhelp/index.html','File_Manager_Help', 'top=' + topo + ',left=' + lefto + ',width=900,height=500,resizable=1');});

    var listener = dbFM.addEventListener(elA, "mouseover", function() { this.className = 'button-selected'; });
    var listener = dbFM.addEventListener(elA, "mouseout", function() { this.className = ''; });
    elSpan.appendChild(elA);

    elTd.appendChild(elSpan);
    elTr.appendChild(elTd);
  }
  //add the top header row to the first table and the first table to the div
  elHTableBody.appendChild(elTr);
  elHTable.appendChild(elHTableBody);
  node.appendChild(elHTable);
 
  //create a second table for the column headers and the content
  var elTable = dbFM.ce('table');  
  elTable.setAttribute('id', this.id + 'mtable');  //added a new identifier 
  var elTableHead = dbFM.ce('thead');
  elTableHead.setAttribute('id', this.id + 'columnhead');

  var elTr = dbFM.ce('tr');
  elTr.setAttribute('id', this.id + 'head');

  // icon column header - this column header contains a home icon allowing the user to return directly to his home directory
  var elTd = dbFM.ce('th');
  elTd.className = 'head';
  var elA = dbFM.ce('a');
  elA.setAttribute('href', '#');
  elA.setAttribute('title', dbFM.js_msg["home"]);
  var elImg = dbFM.ce('img');
  elImg.setAttribute('src', this.iconDir+ '/house.png');
  elImg.setAttribute('alt', dbFM.js_msg["home"]);
  elImg.setAttribute('id', 'home');
  elA.appendChild(elImg);
  //the attached function changes the browser directory
//  var listener = dbFM.addEventListener(elA, "click", function() { GB_show('File Manager: Search',getBaseUrl() + '/dbfm_searchit',300,500,0);});
  var listener = dbFM.addEventListener(elA, "click", function() { dbFM.dirListObj.fetch(getHomeFid()); });
  elTd.appendChild(elA);
  elTr.appendChild(elTd);          //make this a child of the first row

  // Sort columns
  var elTd = dbFM.ce('th');
  elTd.className = 'head';
  var elA = dbFM.ce('a');
  elA.setAttribute('href', '#');
  elA.setAttribute('title', dbFM.js_msg["sort"]);
  
  //conditional on firstChild needed to prevent faults on world's worst browser
  var listener = dbFM.addEventListener(elA, "click", function(e) { wl.sc_n^=1;wl.loadList("n");if(this.firstChild)this.firstChild.src = wl.iconDir + '/' + ((wl.sc_n)?"up":"down") + '.gif'; dbFM.stopEvent(e); });

  var elImg = dbFM.ce('img');
  elImg.setAttribute('alt', dbFM.js_msg["sort"]);
  elImg.setAttribute('src', this.iconDir + '/down.gif');
  elA.appendChild(elImg);
  elA.appendChild(dbFM.ctn(dbFM.js_msg["column1"]));
  elTd.appendChild(elA);
  elTr.appendChild(elTd);

  // date/time column
  var elTd = dbFM.ce('th');
  elTd.className = 'head';
  var elA = dbFM.ce('a');
  elA.setAttribute('href', '#');
  var listener = dbFM.addEventListener(elA, "click", function(e) { wl.sc_m^=1;wl.loadList("m");if(this.firstChild)this.firstChild.src = wl.iconDir + '/' + ((wl.sc_m)?"up":"down") + '.gif';dbFM.stopEvent(e); });

  var elImg = dbFM.ce('img');
  elImg.setAttribute('alt', dbFM.js_msg["sort"]);
  elImg.setAttribute('src', this.iconDir + '/down.gif');
  elA.appendChild(elImg);
  elA.appendChild(dbFM.ctn(dbFM.js_msg["column2"]));
  elTd.appendChild(elA);
  elTr.appendChild(elTd);

  // size column
  var elTd = dbFM.ce('th');
  elTd.className = 'head';
  var elA = dbFM.ce('a');
  elA.setAttribute('href', '#');
  //another IE hack
  var listener = dbFM.addEventListener(elA, "click", function(e) { if(this.firstChild) {wl.sc_s^=1;wl.loadList("s"); this.firstChild.src = wl.iconDir + '/' + ((wl.sc_s)?"up":"down") + '.gif';} dbFM.stopEvent(e); });

  var elImg = dbFM.ce('img');
  elImg.setAttribute('alt', dbFM.js_msg["sort"]);
  elImg.setAttribute('src', this.iconDir + '/down.gif');
  elA.appendChild(elImg);
  elA.appendChild(dbFM.ctn(dbFM.js_msg["column3"]));
  elTd.appendChild(elA);
  elTr.appendChild(elTd);

  elTableHead.appendChild(elTr);
  elTable.appendChild(elTableHead);    //stick the table header into the table
  
  //add somewhere for the real browser rows
  var elTableBody = dbFM.ce('tbody');
  elTableBody.setAttribute('id', this.id + 'body');
    
  elTable.appendChild(elTableBody);

  node.appendChild(elTable);
  parent.appendChild(node);

}  //this is the end of the main list class but we tack on some extra methods below - we need to add all the rows yet!

dbFM.list.prototype.bcrumb = function() {
  var cp = this;
  dbFM.clearNodeById(this.id + 'bcrumb');
  elSpan = dbFM.$(this.id + 'bcrumb');
  var pth = [];
  //loop through the items in the breadcrumb array, the array has 2 members for each entry
  //originally the first member [0] was a v or h to indicate whether or not it should be displayed
  //now it's an fid
  for(var i = 0; i < this.content.bcrumb.length - 1; i++) {
    pth.push(this.content.bcrumb[i][1]);
    //preceed each entry with a slash
    elSpan.appendChild(dbFM.ctn("/"));
    var elA = dbFM.ce('a');
    elA.setAttribute('href', '#');
    // join previous loop iterations to create path for title
    //elA.setAttribute('title', pth.join("/"));
    elA.setAttribute('title', this.content.bcrumb[i][0]); //you can't add an extra fid attribute here
    elA.appendChild(dbFM.ctn(this.content.bcrumb[i][1]));
    //IE fix - click will change to the selected directory
    var listener = dbFM.addEventListener(elA, "click", function(e) { cp.selectBC(e);dbFM.stopEvent(e); });
    elSpan.appendChild(elA);
  }
  elSpan.appendChild(dbFM.ctn("/"));
  elSpan.appendChild(dbFM.ctn(this.content.bcrumb[i][1]));
}

//select a breadcrumb element - used to return the title (path) but now returns a fid
dbFM.list.prototype.selectBC = function(event) {
  var el = event.target||window.event.srcElement
  dbFM.selectFid(el.title);
}

//just calls fetch but if you don't give it an fid it will use the current one
dbFM.list.prototype.refresh = function(fid) {
  if(fid == null) {
    fid = dbFM.current[1];
  }
  this.fetch(fid);
}

//this runs whenever you change directory (including version directories)
//fetch takes a directory's file id as its parameter and calls the ajax 'read' function
dbFM.list.prototype.fetch = function(curr_fid) {
  //we shouldn't need to re-fetch the directory after escaping from a popup screen
  if (dbFM.popUp) {
    dbFM.popUp = false;
    return;
  }
    
  //if we haven't been passed a directory then use the one stored in dbFM.current
  if (curr_fid || (curr_fid = dbFM.current[1])) {
    //update current dir
    dbFM.current[1] = curr_fid;

    dbFM.changeImage('refreshiconlist', 'rrevolve.gif');

    //put in a delay here - I really don't understand why I need it but it doesn't work reliably without it!
    pauseawhile(200);
    //use the AJAX call to read to refresh the directory listings etc.
    if (dbFM.cContent) {
      var postObj = { action:"tread", param0:encodeURIComponent(dbFM.current[1]) };
    }
    else {
      var postObj = { action:"read", param0:encodeURIComponent(dbFM.current[1]) };
    }
    dbFM.HTTPPost(this.url, this.callback, this, postObj);

  } 
}

function pauseawhile(milisecs) {
  var date = new Date();
  var curDate = null;

  do { curDate = new Date(); }
    while(curDate-date < milisecs);
} 

//Return from the server to load content into the file browser - this shouldn't be called when we have an upload popup 
dbFM.list.prototype.callback = function(string, xmlhttp, cp) {

  dbFM.changeImage('refreshiconlist', 'r.gif');
  try { 
    if (xmlhttp.status == 200) {
      //content will now contain an array of stuff about the requested directory, breadcrumb, dirs and files
      cp.content = Drupal.parseJson(string);

      if (cp.content.status) {
        //I've changed the contents of current to include fid so we need to seperate things the format is <path>|<fid>
        dbFM.current = cp.content.current.split("|");
        cp.bcrumb();         //generate the breadcrumb
        cp.loadList("n");
        //clear any tooltips
        if (dbFM.delayID != 0) {
          clearTimeout(dbFM.delayID);
          dbFM.delayID = 0;
        }
        else {
          $('#DH').remove();
        }

      } 
      else {
        //any error message
        alert(cp.content.data);  //dennis prefers popups
      }
    } 
    else {
      //shouldn't happen
      alert(dbFM.js_msg["ajax-err"]);
    }
  }
  catch(e) {
    //failed somewhere - difficult to know where though
    alert("Error: Failed Ajax call - should this recur please contact your sys-admin");
  }
  
}

// Function checks permissions before creating a new directory (using jquery)
dbFM.list.prototype.mkdir = function(e) {

  //now uses JQuery to call the server and check our file permissions
  var pfid = dbFM.current[1];
  $.ajax({
    type: "POST",
    url: this.url,
    data: "action=permcheck&fid=" + pfid,
    success: function(msg){
      //check the return values then call the function to actually make a directory (another ajax call)
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        alert(result.data);   //result.data
        return;
      }
      //prompt for the new directory name
      var dirname = mkdir_prompt();
      //if they've cancelled or left the name blank then give up
      if (dirname == "") {
        return;
      }
      //if the name's too long then give up
      if (dirname.length > getMaxDname()) {
        alert("Directory name is excessively long - choose more sensibly (max. " + getMaxDname() + " chars)");
        return;
      }
      dbFM.changeImage('refreshiconlist', 'rrevolve.gif'); //start the progress object spinning

      //call an ajax poswered subroutine (no return value)
      callmkdir(pfid, this.url, dirname, this);
    }
  });
}

//here's where we build the file list

//sort the rows according to which column is selected e.g "n", "s"
dbFM.list.prototype.loadList = function(sortcol) {

  var parent = dbFM.$(this.id + 'body');
  var grandParent = dbFM.$(this.id);
 
  //this took a few iterations to get it right...
  while( parent.hasChildNodes() ) { 
    parent.removeChild( parent.lastChild );
  }
  
  //the scroll bar won't appear unless the height of the table is known
  //add all the possible entries in the table - if the total is greater than 11 we need to add a
  //scrollbar to the table
  var nentries = this.content.dirs.length + this.content.vers.length + this.content.files.length;
 
  //none of this matters to IE
  if (nentries > 11) {
    parent.setAttribute('height', '335');
  }  
  else {
    parent.setAttribute('height', 'auto');
  }
  // sort then build directory rows and append to table
  if(this.content.dirs.length) {
    this.sortTable(this.content.dirs, sortcol);
    for(var i = 0; i < this.content.dirs.length; i++) {
      var dirrow = new dbFM.dirrow(parent, this.content.dirs[i], i, this.dd_enable, this.dir_cxt_en, this.dir_menu);
    }
  }
  //Build version rows and append to table
  if(this.content.vers.length) {
    this.sortTable(this.content.vers, sortcol);
    for(var i = 0; i < this.content.vers.length; i++) {
      var verrow = new dbFM.verrow(parent, this.content.vers[i], i, this.dd_enable, this.ver_menu);
    }
  }

  // Build file rows and append to table
  // type determines file context menu - note that filerow now takes one less parameter content.db
  //whether or not we enable drag and drop depends on whether we're dealing with a version directory 
  //the contents of which may NOT be dragged and droppped
  if(this.content.files.length) {
    //files within a version directory all have a title starting with Rev - don't allow these to be dragged and dropped
    var fileobj = this.content.files[0];
    //if the first entry is a revision then all will be revisions
    if (fileobj.n.substr(0,4) == "Rev.") {
      this.dd_enable == false;
    }
    this.sortTable(this.content.files, sortcol);
    for(var i = 0; i < this.content.files.length; i++) {
      var filerow = new dbFM.filerow(parent, this.content.files[i], this.type, i, this.dd_enable, this.file_menu);
    }
  }
}

dbFM.list.prototype.sortTable = function(arr, key) {
  switch (key) {
    case "s":
      arr.sort(dbFM.sortBySize);
      if(this.sc_s)
        arr.reverse();
      break;
    case "m":
      arr.sort(dbFM.sortByModified);
      if(this.sc_m)
        arr.reverse();
      break;
    case "n":
      arr.sort(dbFM.sortByName);
      if(this.sc_n)
        arr.reverse();
      break;
  }
}

/**
 * Table directory row object - here's where you add and change what's in your directory listing
 *
 * n - directory name
 * p - full path
 * id - fid
 * m - last modified
 * s - size  currently the number of entries in the directory but will be modified to show the number of directories under
 *     the directory when we start building partial trees
 */
dbFM.dirrow = function(parent, dir, index, dd_enable, cxt_enable, menu) {
  var dr = this;
  this.iconDir = getIconDir();
  //id used for drop container
//  var _id = 'dirlist' + index;
  var _id = 'dir' + dir.id;
  var elTr = dbFM.ce('tr');
  this.element = elTr;
  this.element.className = 'dirrow';

  elTr.setAttribute('id', _id);  //this is the old way of doing it - i'm also going to add a new fid attribute
  elTr.setAttribute('fid', dir.id);  //new fid attribute

  elTr.setAttribute('title', dir.p);
  if(dd_enable) {
    //dbFM.draggable must be created after title assigned to set current path
    this.dd = new dbFM.draggable(elTr, this.element.className);
  }

  //the directory icon in the browser
  var elTd = dbFM.ce('td');
  var elImg = dbFM.ce('img');
  elImg.setAttribute('src', this.iconDir + '/mime/' + dir.icon);  // directory icon
  elImg.setAttribute('id', _id + 'dd');         //hovering will show the full path
  elImg.setAttribute('alt', 'Dir');
  this.menu = menu;
  elTd.appendChild(elImg);
  elTd.setAttribute('class', 'cicon');

  elTr.appendChild(elTd);

  //the directory name in the browser - and the id as the title (appears when you hover)
  var elTd = dbFM.ce('td');
  // Title of link = path
  this.clickObj = dbFM.ce('a');
  this.clickObj.setAttribute('href', '#');
  //title was path - now fid 
  this.clickObj.setAttribute('name', dir.p);
  this.clickObj.setAttribute('title', dir.id);
  

  this.clickObj.appendChild(dbFM.ctn(dir.n));
  elTd.appendChild(this.clickObj);
  elTd.setAttribute('class', 'cfname');  
  elTr.appendChild(elTd);

  //lastmodified date in the browser
  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  
  elTd.setAttribute('class', 'cfmod');

  elTd.appendChild(dbFM.ctn(dir.m));
  elTr.appendChild(elTd);

  //size in the browser - now we don't really want a size displayed ideally we need this hidden? Nah!! we don't need it here
  //at all - only the directory tree would need to know about size - we'll scrap it!
  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  
  elTd.setAttribute('class', 'cfsize');
  
  if(dir.s) {
    var size = dbFM.size(dir.s);
    elTd.appendChild(dbFM.ctn(size));
  }
  elTr.appendChild(elTd);

  //mouse event listeners to execute the appropriate actions for a directory row 
  if(dd_enable) {
    //if it's something we can drag
    var listener = dbFM.addEventListener(this.element, "mousedown", function(e) { dbFM.contextMenuObj.hideContextMenu(); dr.select(e); });
  } 
  else {
    //not draggable
    var listener = dbFM.addEventListener(this.element, "click", function(e) { dbFM.contextMenuObj.hideContextMenu(); if(dbFM.renameActive == false) dbFM.selectFid(dr.element.title); });
  }
  var listener = dbFM.addEventListener(this.element, "mouseover", function() { dr.hover(dr.element, true); });
  var listener = dbFM.addEventListener(this.element, "mouseout", function() { dr.hover(dr.element, false); });
  if(cxt_enable) {
    var listener = dbFM.addEventListener(this.element, "contextmenu", function(e) { if(dbFM.renameActive == false)dbFM.contextMenuObj.showContextMenu(e, dr);dbFM.stopEvent(e); });
  }
  //add the child row to the parent table
  parent.appendChild(elTr);
}

//the state is either true or false (depending on whether you're showing or hiding the pop-up hypertext) el is the element
//just changes the class name to show it's been selected, the css will change the colour of selected elements
dbFM.dirrow.prototype.hover = function(el, state) {
  if(state)
    el.className += '_selected';
  else {
    //remove the word selected - note this used to use a space
    el.className = el.className.split('_', 1);
  }
}

dbFM.dirrow.prototype.select = function(event) {
  var cp = this;
  if(dbFM.renameActive == true)
    return false;
  event = event || window.event;
  switch(event.target||event.srcElement) {
    case this.clickObj:
      // Determine mouse button
      var rightclick = dbFM.rclick(event);
      //if it's a right click then they want the context menu
      if(rightclick)
        break;
      setTimeout(function(){
        //if we're not dragging it then we must want to select it
        if(dbFM.dragging == false) {
//          dbFM.selectDir(cp.element.title);
          dbFM.selectFid(cp.clickObj.title);
        }
      },300);    //lengthened from 200 because it wouldn't work with FF3?? dunno why
      //passthrough
    default:
      this.dd.mouseButton(event);
      break;
  }
  return false;
}

/**
 * Table version row object 
 *
 * n - a concatonation of version and status
 * p - full path
 * id - fid
 * m - last modified
 * s - size  currently the number of entries within the version (NOT the latest version)
 * sub - whether or not we are subscribed to the document
 * e - file extension 
 * t - new parameter (currently filled from the ftitle field) used to provide an image description
 */
dbFM.verrow = function(parent, ver, index, dd_enable, menu) {
  var vr = this;
  this.iconDir = getIconDir();
  //id used for drop container
  var _id = 'ver' + ver.id;
  var elTr = dbFM.ce('tr');
  this.element = elTr;
  this.ext = ver.e;
  this.sub = ver.sub;

  this.element.className = 'verrow';

  elTr.setAttribute('id', _id);  
  elTr.setAttribute('fid', ver.id);  //new fid attribute
  elTr.setAttribute('title', ver.p);
  if(dd_enable) {
    //dbFM.draggable must be created after title assigned to set current path
    this.dd = new dbFM.draggable(elTr, this.element.className);
  }
  //the version icon in the browser 
  var elTd = dbFM.ce('td');
  var elImg = dbFM.ce('img');
  elImg.setAttribute('src', this.iconDir + '/mime/' + ver.icon);
  elImg.setAttribute('alt', 'Ver');
  this.menu = menu;
  elTd.appendChild(elImg);
  elTd.setAttribute('class', 'cicon');

  elTr.appendChild(elTd);

  //the version directory name in the browser - and the id as the title (appears when you hover)
  var elTd = dbFM.ce('td');
  // Title of link = path
  this.clickObj = dbFM.ce('a');
  this.clickObj.setAttribute('href', '#');
  this.clickObj.setAttribute('title', ver.id);
  this.clickObj.setAttribute('id', ver.id);
  this.clickObj.setAttribute('name', ver.n);  //why was this e rather than n??
  this.clickObj.appendChild(dbFM.ctn(ver.n));
  elTd.appendChild(this.clickObj);
  elTd.setAttribute('class', 'cfname');
  elTr.appendChild(elTd);

  //lastmodified date in the browser
  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  elTd.appendChild(dbFM.ctn(ver.m));
  elTd.setAttribute('class', 'cfmod');

  elTr.appendChild(elTd);

  //size in the browser - now we don't really want a size displayed for a version directory ideally we need this hidden? 
  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  if(ver.s) {
    var size = dbFM.size(ver.s);
    elTd.appendChild(dbFM.ctn(size));
  }
  elTd.setAttribute('class', 'cfsize');
  elTr.appendChild(elTd);


  //mouse event listeners to execute the appropriate actions for a version row ZZZZ directories will need properties
  //to show permissions - number of items etc.
  if(dd_enable) {
    var listener = dbFM.addEventListener(this.element, "mousedown", function(e) { dbFM.contextMenuObj.hideContextMenu(); vr.select(e); });
  } 
  else {
    var listener = dbFM.addEventListener(this.element, "click", function(e) { dbFM.contextMenuObj.hideContextMenu(); if(dbFM.renameActive == false)dbFM.selectFile(fr.element); });
  }
  var listener = dbFM.addEventListener(this.element, "mouseover", function(e) { dbFM.hEvent = Drupal.mousePosition(e); vr.hover(vr, true); });
  var listener = dbFM.addEventListener(this.element, "mouseout", function() { vr.hover(vr, false); });
  var listener = dbFM.addEventListener(this.element, "contextmenu", function(e) { if (dbFM.renameActive == false) dbFM.contextMenuObj.showContextMenu(e, vr);dbFM.stopEvent(e); });

  parent.appendChild(elTr);
}

dbFM.verrow.prototype.hover = function(el, state) {
  //we're going to call the show function passing the url on the server that will return the file information
  dbFM.newurl = getBaseUrl() + '/dbfm_hover/' + el.clickObj.id;
  
  //test whether the file is likely to be an image (based on the extension and not really guaranteed for versions)
  var fext = el.clickObj.name;
  var ext = fext.toLowerCase();  
  dbFM.clickObj = dbfmITest(ext);
  
  //don't display the box immediatly - give them a second and a half to decide if they really want it - and don't display it if the tooltips flag has been
  //set - the flag indicates that the user is already doing something else
  if (state && dbFM.tooltips) {
    dbFM.delayID = setTimeout("DH_show(dbFM.newurl, dbFM.clickObj)",1500); 
  }
    
  else {
    //cancel any previous timeouts
    if (dbFM.delayID != 0) {
      clearTimeout(dbFM.delayID);
      dbFM.delayID = 0;
    }
    else {
      $('#DH').remove();
    } 
  } 
}


dbFM.verrow.prototype.select = function(event) {
  var cp = this;
  if(dbFM.renameActive == true)
    return false;
  event = event || window.event;
  switch(event.target||event.srcElement) {
    case this.clickObj:
      // Determine mouse button
      var rightclick = dbFM.rclick(event);
      //should trigger the context menu
      if(rightclick) {
        break;
      }
      setTimeout(function(){
        //if we're not dragging it then we must want to select it (open / download the file)
        if (dbFM.dragging == false) {
          dbFM.selectFile(cp.element);
        }
      },300);
      //passthrough
    default:
      this.dd.mouseButton(event);
      break;
  }
  return false;
}


//got rid of the 7th parameter which indicated whether or not the file was in the database
/**
 * dbFM.filerow constructor
 *
 * 1st param is parent obj
 * 2nd param is fileobject (see desc below)
 * 3rd param is base id name of file row
 * 4th param is unique number to append to id
 * 5th param enables drag and drop
 * 6th param is directory menu array
  *
 * fileobject elements:
 * id -> fid
 * n -> file name 
 * p -> path (doesn't include name)
 * s -> file size
 * sub -> whether or not we are subscribed to the document
 * m -> modified date
 * e -> mimetype extension
 * i -> image file.
 * w -> image width
 * h -> image height
 * t -> currently populated from the ftitle field - used to store the image description
 */
 dbFM.filerow = function(parent, fileObj, idtype, index, dd_enable, file_menu) {
  var fr = this;
  this.iconDir = getIconDir();
  this.ext = fileObj.e;
  this.sub = fileObj.sub;
  this.filepath = fileObj.p + '/' + fileObj.n;
  var elTr = dbFM.ce('tr');
  this.element = elTr;
  this.fid = fileObj.id;    //I'm not sure this is used anywhere
  elTr.className = idtype + 'row';
  if (fileObj.id == 0)
    this.row_id = idtype + index;
  else
    this.row_id = 'fid' + fileObj.id;
  elTr.setAttribute('id', this.row_id);

  //title of drag object is path for move - don't modify this
  elTr.setAttribute('title', this.filepath);
  //only make the object draggable if we're not in a version directory
  if (dd_enable) {
    if (!dbFM.verdir) {
      this.dd = new dbFM.draggable(elTr, elTr.className);
    }
  }

  var elTd = dbFM.ce('td');
  var elImg = dbFM.ce('img');
  elImg.setAttribute('src', this.iconDir + '/mime/' + fileObj.icon);
  elImg.setAttribute('alt', 'File');
  this.menu = file_menu;
  elTd.appendChild(elImg);
  elTd.setAttribute('class', 'cicon');

  elTr.appendChild(elTd);

  //sets the clickobj title to id if known 
  var elTd = dbFM.ce('td');
  this.clickObj = dbFM.ce('a');

  //give it a unique ID - I don't belive the class is actually necessary since we're manually pointing it to a hover function
  this.clickObj.setAttribute('id', fileObj.id);
  this.clickObj.setAttribute('name', fileObj.n);
  this.clickObj.setAttribute('href', '#');
  this.clickObj.setAttribute('title', fileObj.id);
  //uses the filename here
  this.clickObj.appendChild(dbFM.ctn(fileObj.n)); 
  elTd.appendChild(this.clickObj);
  elTd.setAttribute('class', 'cfname');

  elTr.appendChild(elTd);

  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  elTd.appendChild(dbFM.ctn(fileObj.m));
  elTd.setAttribute('class', 'cfmod');

  elTr.appendChild(elTd);

  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  var size = dbFM.size(fileObj.s);
  elTd.appendChild(dbFM.ctn(size));
  elTd.setAttribute('class', 'cfsize');
  elTr.appendChild(elTd);

  //mouse event listeners for a file row 
  if(dd_enable)
    var listener = dbFM.addEventListener(this.element, "mousedown", function(e) { dbFM.contextMenuObj.hideContextMenu(); fr.select(e); });
  else
    var listener = dbFM.addEventListener(this.element, "click", function(e) { dbFM.contextMenuObj.hideContextMenu(); if(dbFM.renameActive == false)dbFM.selectFile(fr.element); });

  // the event has to be saved in a 'global', dbFM.hEvent, since we need to know the mouse position when showing the tooltip hover-box 
  var listener = dbFM.addEventListener(this.element, "mouseover", function(e) { dbFM.hEvent = Drupal.mousePosition(e); fr.hover(fr, true); });
  var listener = dbFM.addEventListener(this.element, "mouseout", function(e) { fr.hover(fr, false); });
  
  var listener = dbFM.addEventListener(this.element, "contextmenu", function(e) { if(dbFM.renameActive == false)dbFM.contextMenuObj.showContextMenu(e, fr);dbFM.stopEvent(e); });

  parent.appendChild(elTr);
}

//note that alert's will not work in the event handlers
dbFM.filerow.prototype.hover = function(el, state) {
  //we're going to call the show function passing the url on the server that will return the file information
  dbFM.newurl = getBaseUrl() + '/dbfm_hover/' + el.clickObj.id;

  //test whether the file is an image
  var fname = el.clickObj.name;
  var pos = fname.lastIndexOf('.') + 1; 
  if (pos == -1) {
    alert("Invalid filename");
    return false;
  }
  var extmc = fname.substring(pos);  
  var ext = extmc.toLowerCase();  
  dbFM.clickObj = dbfmITest(ext);

  //don't display the box immediatly - give them a second and a half to decide if they really want it - and don't display it if the tooltips flag has been
  //set - the flag indicates that the user is already doing something else
  if (state && dbFM.tooltips) {
    dbFM.delayID = setTimeout("DH_show(dbFM.newurl, dbFM.clickObj)",1500); 
  }
  else {
    //cancel any previous timeouts
    if (dbFM.delayID != 0) {
      clearTimeout(dbFM.delayID);
      dbFM.delayID = 0;
    }
    else {
      $('#DH').remove();
    } 
  } 
}

dbFM.filerow.prototype.select = function(event) {
  dbFM.verflag = false;
  var cp = this;
  if(dbFM.renameActive == true)
    return false;
  event = event || window.event;
  switch(event.target||event.srcElement) {
    case this.clickObj:
      // Determine mouse button - rightclick is just for the context menu
      var rightclick = dbFM.rclick(event);
      if (rightclick)
        break;

      //if nothing else happens during the 200ms timeout 
      setTimeout(function(){
        //if click then no dragging...
        if (dbFM.dragging == false) {
          dbFM.selectFile(cp.element);
        }
      },300);
      //passthrough
    default:
      //files that are within a version directory won't have this property
      if (this.dd) {
        this.dd.mouseButton(event);
        break;
      }
  }
  return false;
}

/**
 * dbFM.changeimage
 *
 * 1st param is the id of the image
 * 2nd param is the image to replace it with
 */
dbFM.changeImage = function(id, image) {
  var icondir = getIconDir();
  imageElement = dbFM.$(id);
  imageElement.src = (icondir + '/' + image);
}

/**
 * dbFM.tree constructor
 * 1st param is the parent object to which the tree will be added
 * 2nd param is base id of listing (multiple tree objects must have unique ids) - e.g. dirtree - will we ever need more than one??
 * that could simplify things a bit more ZZZZZZZZ
 * 3rd param is name of tree (doesn't matter "Directory") this needn't be a parameter
 * 4th param is ajax fetch operation e.g "readtree" - since this is fixed it shouldn't really be a parameter anymore (different
 * when there was an ftp tree
 * 5th param is root directory menu array - what context options are available for root
 * 6th param is non-root directory menu array - what context options are available for directories
 */
dbFM.tree = function(parent, id, treeTitle, op, root_menu, dir_menu) {
  var wt = this;
  this.id = id;
  this.action = op;
  this.icondir = getIconDir();
  this.content = '';
  this.rootId = id + 'root';   //eg 'dirtree' + root
  this.expAllData = [['collapse', 'minus', 'block'], ['expand', 'plus', 'none']];
  // Set tree exp/collapse behaviour on load (0 = expanded, 1 = collapsed) - I'm not sure we'l ever use expanded
  this.expAllIndex = 1;
  this.root_menu = root_menu;
  this.dir_menu = dir_menu;


  var node = dbFM.ce("div");
  node.setAttribute('id', id);

  //build tree and display
  var elA = dbFM.ce('a');
  
  elA.setAttribute('href', '#');
  elA.setAttribute('title', dbFM.js_msg["refresh"]);
  var listener = dbFM.addEventListener(elA, "click", function(e) { wt.fetch();dbFM.stopEvent(e); });

  var elImg = dbFM.ce('img');
  elImg.setAttribute('src', this.icondir + '/r.gif');
  elImg.setAttribute('alt', dbFM.js_msg["refresh"]);
  elImg.setAttribute('id', 'refreshicontree');
  elA.appendChild(elImg);
  node.appendChild(elA); 
  node.appendChild(dbFM.ctn(' ' + treeTitle + ' Tree'));

  // Expand/Collapse all folders buttons
  var elSpan = dbFM.ce("span");
  elSpan.setAttribute('id', id + 'exp');
  //there's only 2 - is it worth building them in a for loop?
  for(var i = 0; i < 2; i++) {
    var elA = dbFM.ce('a');
    elA.setAttribute('href', '#');
    if (i) {
      //function (loaded from the server) checks whether dbfm setup specified the expand all button should be removed
      if (getExpOpt()) {
        elA.setAttribute('title', 'expand tree');
        var listener = dbFM.addEventListener(elA, "click", function(e) { wt.exp(0);dbFM.stopEvent(e); });
      }
      else {
        break;  //we've finished building the controls
      }
    } 
	else {
        elA.setAttribute('title', 'collapse tree');
        var listener = dbFM.addEventListener(elA, "click", function(e) { wt.exp(1);dbFM.stopEvent(e); });
    }
    var elImg = dbFM.ce('img');
    //fills the alt tabs for the tree?
    elImg.setAttribute('alt', this.expAllData[i][0]);
    elImg.setAttribute('src', this.icondir + '/' + this.expAllData[i][1] + '.gif');
    elA.appendChild(elImg);
    elSpan.appendChild(elA);
  }
  node.appendChild(elSpan);

  var rootDiv = dbFM.ce("div");
  rootDiv.setAttribute('id', this.rootId);

  node.appendChild(rootDiv);

  parent.appendChild(node);
}

dbFM.tree.prototype.fetch = function(list) {
  // Reset ul count (0=root)
  this.treeUlCounter = 0;
  this.treeNodeCounter = 0;
  this.list = list;

  //where is the action set??
  var url = dbFM.ajaxUrl();
  dbFM.changeImage('refreshicontree', 'rrevolve.gif');

  //wipe out the preview pane, we'll put in an icon and appropriate text
//  dbFM.filetitle = "No File Selected";
//  dbfmImagePreviewDisplay(getIconDir() + '/no-preview.png');


  var postObj = { action:encodeURIComponent(this.action) };
  dbFM.HTTPPost(url, this.callback, this, postObj);
}

//ZZZZZZZdoes this need to display any other errors - is status ever false??
dbFM.tree.prototype.callback = function(string, xmlhttp, cp) {
  dbFM.changeImage('refreshicontree', 'r.gif');
  if (xmlhttp.status == 200) {
    cp.content = Drupal.parseJson(string);

    //clear dir_tree div
    dbFM.clearNodeById(cp.rootId);
    dbFM.dropContainers = [];

    //store the current directory and fid in a global variable - this will always be fid 1??
    dbFM.current = cp.content.current.split("|");

    // Recursively build directory tree from php associative array
    var parent = dbFM.$(cp.rootId);    //the root element that we're glueing all this to
    cp.buildTreeRecur(cp.content.tree, parent, '');  //initial call of the recurring function thath will build the tree, path starts empty
    cp.init();

    if (cp.list)
      //we're finished - now build the directory listing (for the root directory
      dbFM.changeImage("uploadIcon", "folder_page_white.png");
      dbFM.changeImage("mkdirIcon", "folder_add.png");

 //     dbFM.verdir = false;   //reset the flag to indicate we're not looking at a version directory?? Why?? surely that is determined purely 
                             //from the list
  } 
  else {
    alert(dbFM.js_msg["ajax-err"]);
  }

}


dbFM.tree.prototype.showHideNode = function (event) {
  event = event || window.event;
  var collapseIcon = event.target||event.srcElement;
  if(collapseIcon.style.visibility == 'hidden')
    return;
  var ul = collapseIcon.parentNode.parentNode.getElementsByTagName('ul')[0];
  if(collapseIcon.title == this.expAllData[0][0]) {
    collapseIcon.src = this.icondir + '/' + this.expAllData[1][1] + '.gif';
    collapseIcon.alt = this.expAllData[1][0];
    collapseIcon.title = this.expAllData[1][0];
    ul.style.display = this.expAllData[1][2];
  }else{
    collapseIcon.src = this.icondir + '/' + this.expAllData[0][1] + '.gif';
    collapseIcon.alt = this.expAllData[0][0];
    collapseIcon.title = this.expAllData[0][0];
    ul.style.display = this.expAllData[0][2];
  }
}
//parameters are the tree data as returned by the ajax call, the parent tree object and
//the third parameter, the path, starts empty and is built up on recurrent calls
dbFM.tree.prototype.buildTreeRecur = function(content, parent, input_path) {
  var cp = this;
  //php associative array is always a single member array with nested objects
  //sometimes this test fails - do we know a better way of testing whether  this is an array?
  if(dbFM.isArray(content)) {
    this.buildTreeRecur(content[0], parent, '');
  } 
  else if (dbFM.isObject(content)) {
    if(input_path)
      input_path += "/";
    var elUl = dbFM.ce('ul');
    //note the id here is not the fid - it's the id of the tree element
    elUl.setAttribute('id', this.id + '_ul_' + this.treeUlCounter++);
    // sort object here since php does not have a case-sensitive ksort
    var sortDir = [];
    for (var i in content) {
      sortDir.push(i);
    }
    //all the directory names are in the array sortdir - we'll have to strip the fid's from the end of each sortdir entry
    if(sortDir.length) {
      var splitit = []; //we use this array to split each entry into a name[0] and an fid[1]

      sortDir.sort(dbFM.sortByKey);
      for(var j = 0; j < sortDir.length; j++) {
        splitit = sortDir[j].split("|");
        var newpath = input_path + splitit[0];
        var elLi = dbFM.ce('li');
        var _id = this.id + 'node' + this.treeNodeCounter;
        elLi.setAttribute('id', _id);
        elLi.setAttribute('title', newpath);
        elLi.setAttribute('fid', splitit[1]);
        elLi.className = this.treeNodeCounter ? 'treenode':'treeroot';

        //an imageset for the element (not just a directory icon but also the expand icon
        var elDiv = dbFM.ce('div');
        var elImg = dbFM.ce('img');
        elImg.setAttribute('src', this.icondir + '/' + this.expAllData[this.expAllIndex][1] + '.gif');
        elImg.setAttribute('alt', this.expAllData[this.expAllIndex][0]);
        elImg.setAttribute('title', this.expAllData[this.expAllIndex][0]);
        elDiv.appendChild(elImg);
        elLi.appendChild(elDiv);
        var listener = dbFM.addEventListener(elImg, "click", function(e) { cp.showHideNode(e);dbFM.stopEvent(e); });
        //added a new element to the treenode - the fid (passed as the 4th parameter
        var treeNode = new dbFM.treeNode(elDiv, newpath, _id, splitit[1], elImg, this.treeNodeCounter ? this.dir_menu : this.root_menu);
        this.treeNodeCounter++;
        this.buildTreeRecur(content[sortDir[j]], elLi, newpath);
        elUl.appendChild(elLi);
      }
    }

    // Always show root
    if(elUl.id == this.id + '_ul_0')
      elUl.style.display='block';
    else
      elUl.style.display = this.expAllData[this.expAllIndex][2];

    parent.appendChild(elUl);
  }
}

dbFM.tree.prototype.init = function() {
  var rootDiv = dbFM.$(this.rootId);
  // Determine if expand/collapse icon is present
  // Create event objects for each element
  var dirItems = rootDiv.getElementsByTagName('li');
  if (dirItems.length) {
    for(var i = 0; i < dirItems.length; i++) {
      var subItems = dirItems[i].getElementsByTagName('ul');
      if(!subItems.length)
        // Hide collapse icon if no sub-directories
        dirItems[i].getElementsByTagName('img')[0].style.visibility='hidden';
    }
  }
}

dbFM.tree.prototype.exp = function(expcol) {
  dbFM.clearNodeById(this.rootId);
  var _tree = dbFM.$(this.rootId);

  // Rebuild dirtree ul/li objects from dirtree object
  this.expAllIndex = expcol;
  this.treeUlCounter = 0;
  this.treeNodeCounter = 0;

  this.buildTreeRecur(this.content.tree, _tree, '');
  this.init();
}

// a new attribute - fid has been added to each treenode
dbFM.treeNode = function(parent, path, id, fid, expImg, menu) {
  var tn = this;
  this.parent = parent
  this.element = parent.parentNode;
  var icondir = getIconDir();
  this.expClickObj = expImg;

  var elImg = dbFM.ce('img');
  elImg.setAttribute('id', id + 'dd');
  elImg.setAttribute('src', icondir + '/d.gif');
  parent.appendChild(elImg);

  this.clickObj = dbFM.ce('a');
  this.clickObj.href = '#';
  this.clickObj.setAttribute('id', id + 'xx');
  // title was path and has been changed to fid
  this.clickObj.setAttribute('title', fid);
  if (this.element.className != 'treeroot') {
    // root isn't draggable
    this.dd = new dbFM.draggable(this.element, this.element.className);
  }
  var root = [];
  root = path.split('/');
  //textNode is last directory name of path string
  this.clickObj.appendChild(dbFM.ctn(root[root.length - 1]));
  parent.appendChild(this.clickObj);

  //mouse event listeners
  this.menu = menu;
  if(this.dd) {
    //incase you're wondering tn.select is treenode select
    var listener = dbFM.addEventListener(parent, "mousedown", function(e) { dbFM.contextMenuObj.hideContextMenu();  tn.select(e); });
  } 
  else {
//    var listener = dbFM.addEventListener(parent, "click", function(e) { dbFM.selectDir(tn.clickObj.title); dbFM.stopEvent(e); });
    var listener = dbFM.addEventListener(parent, "click", function(e) { dbFM.selectFid(tn.clickObj.title); dbFM.stopEvent(e); });
  }
  //the mouseover and out functions change the class name which allows the css to highlight the selected item
  var listener = dbFM.addEventListener(parent, "mouseover", function() { this.className = 'selected'; });
  var listener = dbFM.addEventListener(parent, "mouseout", function() { this.className = ''; });
  var listener = dbFM.addEventListener(parent, "contextmenu", function(e) { if(dbFM.renameActive == false)dbFM.contextMenuObj.showContextMenu(e, tn);dbFM.stopEvent(e); });
}

dbFM.treeNode.prototype.select = function(event) {
  var cp = this;
  // disable during rename
  if(dbFM.renameActive == true)
    return false;
  event = event|| window.event;
  switch(event.target||event.srcElement) {
    case this.expClickObj:
      break;
    case this.clickObj:
      // Determine mouse button
      var rightclick = dbFM.rclick(event);
      if(rightclick)
        // oncontextmenu will handle this
        break;
      setTimeout(function(){
        //if they're not dragging then select the directory. Changed the code so that title contains the fid
        if(dbFM.dragging==false) {
//          dbFM.selectDir(cp.clickObj.title);
           dbFM.selectFid(cp.clickObj.title);
      }},200);
      //passthrough
    default:
      this.dd.mouseButton(event);
      break;
  }
  return false;
}
//one or the otherZZZZZZZZZZZZZZZZ selectDir will be disposed of - or maybe not?? is it best to keep it for drag and drop??!!
dbFM.selectDir = function(path) {
  dbFM.verdir = false;   //reset the flag to indicate we're not looking at a version directory
  dbFM.changeImage("uploadIcon", "folder_page_white.png");
  dbFM.changeImage("mkdirIcon", "folder_add.png");
  dbFM.dirListObj.fetch(path);
}

//this is called when you click on a directory in the filebrowser or tree
dbFM.selectFid = function(fid) {
  dbFM.verdir = false;   //reset the flag to indicate we're not looking at a version directory
  dbFM.changeImage("uploadIcon", "folder_page_white.png");
  dbFM.changeImage("mkdirIcon", "folder_add.png");
  dbFM.dirListObj.fetch(fid);
}

//this is used to select and display an individual file - I don't understand what the as_file parameter does
dbFM.selectFile = function(el, as_file) {
// to allow directory downloads from the tree, we need to check whether we've got a treenode or browser
//  var fid = el.id.substring(3);
  if(el.id.match('treenode') == null) {
    // browser object with 3-char prefix
    var fid= el.id.substring(3);
  } else {
    var fid = dbFM.$(el.id + 'xx').title;
  }

  path = 'dbfm_send/' + fid;
  //what is this?? - send can acept a parameter 1 is attach, 0 is inline (default is inline)
  if(as_file == true)
      path += '/1';

  //window open is to open a new browser window rather than dumping everything in the existing window
  var cleanUrl = getCleanUrl();
  if (cleanUrl) {
    var url = getBaseUrl();
    window.open(url + '/' + path);
  }
  else {
    window.open('?q=' + path);
  }
}

/**
 * dbFM.context constructor
 */
dbFM.context = function() {
  dbFM.renameActive = false;
}

// Hides context menu by setting display to 'none' and restores document mouse handlers. Re-enables the tooltips
dbFM.context.prototype.hideContextMenu = function() {
  dbFM.contextMenuDiv.style.display = 'none';  //make context menu invisible - note: the contents are not erased until next time the 'Show' is invoked.
  document.body.oncontextmenu = dbFM.oldOnContextMenu;
  document.onmousedown = dbFM.oldOnMouseDown;
  //re-enable tooltips
  dbFM.tooltips = true;
  if (dbFM.conTimeOut != 0) {
    clearTimeout(dbFM.conTimeOut);
    dbFM.conTimeOut = 0;
  }
}

//obj is treenode|filerow|verrow|dirrow|attachrow
//the original code had no provision for the menu disappearing off the bottom of the screen
//I've added and extra function to display the menu higher on the screen
//this function will display the context menu and provide listeners to respond to the menu selection
dbFM.context.prototype.showContextMenu = function(event, obj) {
  var cp = this;
  this.element = obj.element;
  this.clickObj = obj.clickObj;
  document.body.oncontextmenu = new Function ("return false");
  event = event || window.event;

  //prevent the tooltip box from being displayed by setting any timeout to zero and setting a flag (which is reset when the context menu is cleared)
  //note that this is unnecessary on the attachrow entries since there are no tooltips
  if (dbFM.delayID != 0) {
    clearTimeout(dbFM.delayID);
    dbFM.delayID = 0;
  }
  dbFM.tooltips = false;
  
  //workout where the menu will be displayed (to avoid it going off-screen)
  var pos = Drupal.mousePosition(event);
  
  var cH = document.body.clientHeight; 
  var theRatio = getConRatio();

  // wipe any existing list in our contextMenu (otherwise the menu gets ever longer!).
  dbFM.clearNodeById('cxtCont');

  // Build menu ul and append to dbFM.contextMenuDiv
  if(obj.menu != null) {
    var elUl = dbFM.ce('ul');
    //for each menu option
    for(var j = 0; j < obj.menu.length; j++) {
      var elLi = dbFM.ce('li');
      //Run prepare function and return true if menuElement to appear in menu
      if (typeof(obj.menu[j].prepFunc) == 'function' && !obj.menu[j].prepFunc(obj)) {
        continue;
      }
      
      elLi.appendChild(dbFM.ctn(obj.menu[j].desc));
      //menu selection is title of event
      elLi.id = 'cxtMenu' + j;
      var listener = dbFM.addEventListener(elLi, "mousedown", function(e) { cp.selectMenu(e, obj); cp.hideContextMenu(); dbFM.stopEvent(e); });
      //mouseover and mouseout are just used to highlight the item you're currently over
      var listener = dbFM.addEventListener(elLi, "mouseover", function(e) { cp.hover(e, true); });
      var listener = dbFM.addEventListener(elLi, "mouseout", function(e) { cp.hover(e, false); });
      elUl.appendChild(elLi);
    } //end of the for loop building the menu
    
    dbFM.contextMenuDiv.appendChild(elUl);

    //adjust the left / x co-ordinate
    if  (pos.x + dbFM.contextMenuDiv.offsetWidth > (document.documentElement.offsetWidth-20)) {
      pos.x = pos.x + (document.documentElement.offsetWidth - (pos.x + dbFM.contextMenuDiv.offsetWidth)) - 20;
    }
    
    dbFM.contextMenuDiv.style.left = pos.x + 'px';
    //if we're too close to the bottom of the screen then we flip the menu up
    var sRatio = pos.y/cH;
    
    //ok - I tried to use a magic number to determine when the menu flips - but it seems pretty specific to the individual site - it's down to how much of 
	//the screen is taken up by menus on the left - so we need to make this a configurable value on each server set up though the admin screen
	//NOW the fiddle factor doesn't work if it's just on the node screen (attachment menu) so we need to test for this

    //test whether we're in a popup (true) or this is the main dbFM screen
    if (dbFM.cContent) {
      if (sRatio > theRatio) {
        //need to flip it - I tried to set the bottom but got some strange effects so instead we'll do a little calculation to raise all
        //menus to a certain height
        var fiddle = sRatio - (theRatio - 0.05);
        var posy2 = pos.y -(fiddle * cH);
        dbFM.contextMenuDiv.style.top = posy2 + 'px';
      }
      else {
        dbFM.contextMenuDiv.style.top = pos.y + 'px';
      }
    }
    else {
      //we're either in a normal dbfm browser or on the node screen, if in a dbfm browser lets see how big our viewport window is and try not to go out the bottom
      if (obj.element.className == 'attrow') {
        //safari causes problems because you need to allow for the scroll position
        if (dbFM.browser.isSafari) {
          pos.y = pos.y + document.body.scrollTop;
        }
	  }
	  else {
	    var theViewport = $(window).height();
        if ((theViewport - pos.y) < 190) {
	      pos.y = theViewport - 190;
	    }
	  }
      dbFM.contextMenuDiv.style.left = pos.x + 'px';
      dbFM.contextMenuDiv.style.top = pos.y + 'px';
    }
    
    dbFM.contextMenuDiv.style.display ='block';
    dbFM.contextMenuDiv.style.zIndex = ++dbFM.zindex;
  }
  // set a timeout which will hide the context menu if nothing has been selected for greater than 4 seconds
  dbFM.conTimeOut = setTimeout("dbFM.contextMenuObj.hideContextMenu()",4000);
  
  var listener = dbFM.addEventListener(document, "mousedown", function(e) { cp.hideContextMenu(); });
  return false;
}

//the original code allowed a context menu to persist even if the mouse was nowhere near it - what we now do
//is check whether any elements are selected - if not then we set a short timeout and dismiss the context menu
//unless it's accessed during that timeout. Which comes first mouse-over or mouse-out?? I'm assuming mouse-out comes first!
// IE does not understand 'this' inside event listener func
dbFM.context.prototype.hover = function(event, state) {
  var el = event.target||window.event.srcElement
  el.className = state ? 'cxtContHover' : '';
  if (state) {
    //something's been selected - reset any timeouts
    el.className = 'cxtContHover';
    if (dbFM.conTimeOut != 0) {
      clearTimeout(dbFM.conTimeOut);
      dbFM.conTimeOut = 0;
    }
  }
  else {
    el.className = '';
    dbFM.conTimeOut = setTimeout("dbFM.contextMenuObj.hideContextMenu()",4000)
  }
}

// Call dbFM.menuElement execute function - called by the context menu listeners
dbFM.context.prototype.selectMenu = function(event, obj) {
  event = event || window.event;
  //needs a comment here to say what we're doing - what's that substring stuff? ZZZZZZZZZZZZZZZZ
  obj.menu[(event.target||event.srcElement).id.substring(7,8)].execFunc(obj);
  return false;
}


dbFM.menuElement = function(desc, execFunc, prepFunc) {
  this.desc = desc;
  this.execFunc = execFunc;
  this.prepFunc = prepFunc;
}

//obj is treenode|filerow|dirrow
dbFM.menuElement.prototype.exec = function(obj) {
  this.execFunc(obj);
}

//delete function as called from the context menu
dbFM.menuRemove = function(obj) {
  var url = dbFM.ajaxUrl();
  obj.is_file = ((obj.element.className != 'dirrow') && (obj.element.className.substring(0,4) != 'tree'));
  var path = obj.element.title;
  //we have to test first whether we've been called from the tree or the browser
  if (obj.element.id.match('treenode') == null) {
    //the id of a browser object has a 3 character prefix - e.g 'dir' + id or 'fid' + id or 'ver' + id - we need to strip this
    var fid = obj.element.id.substr(3);
  }
  else {
    var fid = dbFM.$(obj.element.id + 'xx').title;
  }

  //the function permatt both checks permissions AND checks whether the file has any attachments
  if (obj.is_file) {
    var chkMes = "Do you want to delete the file <" + path + "> ?";
    var paction = "action=permatt&fid=" + fid;
  }
  else {
    var paction = "action=permatt&fid=" + fid + "&recur=true";
    var chkMes = "Do you want to delete the directory <" + path + "> and all its contents?";
  }

  //now we know the fileID we need to check whether we have permission to delete this file or directory - if we're checking a 
  //directory we need a recursive check.
  $.ajax({
    type: "POST",
    url: url,
    data: paction,
    success: function(msg){

      //check the return values then call the function to actually delete things
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        alert(result.data);
        return;
      }
      if (result.attach == true) {
        //we need to change the check message
        chkMes = result.data;
      }
      //prompt to check they REALLY want to go ahead 
      if(dbFM.confirm(chkMes)) {
        dbFM.changeImage('refreshiconlist', 'rrevolve.gif'); //start the progress object spinning
        reallyDelete(url,obj, fid);
      }
    }
  });
}
//no this doesn't really delete anything - the server just marks it as deleted by changing the parent fid to a negative value
function reallyDelete(url, obj, fid) {
  //call the server to delete the object
    var postObj = { action:"delete", param0:encodeURIComponent(fid) };
    dbFM.HTTPPost(url, dbFM.ctx_callback, obj, postObj);
}


//this is mkdir as called from the context menu (from the tree or browser)
dbFM.menuMkdir = function(obj) {
  //now uses JQuery to call the server and check our file permissions
  var url = dbFM.ajaxUrl();

  //we have to test first whether we've been called from the tree or the browser
  if (obj.element.id.match('treenode') == null) {
    //the id of a browser object has a 3 character prefix - e.g 'dir' + id or 'fid' + id or 'ver' + id - we need to strip this
    var pfid = obj.element.id.substr(3);
  }
  else {
    var pfid = dbFM.$(obj.element.id + 'xx').title;
  }

  $.ajax({
    type: "POST",
    url: url,
    data: "action=permcheck&fid=" + pfid,
    success: function(msg){
      //check the return values then call the function to actually make a directory (another ajax call)
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        alert(result.data);
        return;
      }

      //prompt for the new directory name
      var dirname = mkdir_prompt();
      //if they've cancelled or left the name blank then give up
      if (dirname == "") {
        return;
      }
      //if the name's too long then give up
      if (dirname.length > 40) {
        alert("Directory name is excessively long - choose more sensibly (max. 40 chars)");
        return;
      }
      dbFM.changeImage('refreshiconlist', 'rrevolve.gif'); //start the progress object spinning

      //call an ajax poswered subroutine (no return value)
      callmkdir(pfid, url, dirname, this);
    }
  });
}

//this is a mickey-mouse search called from a directory's context menu
dbFM.menuFSearch = function(obj) {
  //we have to test first whether we've been called from the tree or the browser
  if (obj.element.id.match('treenode') == null) {
    //the id of a browser object has a 3 character prefix - e.g 'dir' + id or 'fid' + id or 'ver' + id - we need to strip this
    var pfid = obj.element.id.substr(3);
  }
  else {
    var pfid = dbFM.$(obj.element.id + 'xx').title;
  }

  //it merely invokes a greybox which allows the user to enter a keyword to search for BUT it has to send back the fid of the directory
  //because we're only searching the directories beneath that. I tried first to return s path but each slash is seen as a new parameter 
  //so that doesn't work 
  //added the path to the GB title
  GB_show('Directory Search - ' + obj.element.title, getBaseUrl() + '/dbfm_fnsearch/' + pfid, 480, 640, 0);
}

//rename, on the other hand, is always called from the context menu and takes as parameter the object
dbFM.menuRename = function(obj) {
  //I originally had code here to stop tooltips from kicking off - however at the same time as this runs the context menu is
  //being hidden - and resetting the flag that would stop tooltips
  
  //first we need to check whether we have write permissions on the object before we can rename it
  var url = dbFM.ajaxUrl();

  $.ajax({
    type: "POST",
    url: url,
    data: "action=permcheck&fid=" + obj.element.id.substr(3),
    success: function(msg){
      //check the return values then call the function to actually make a directory (another ajax call)
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        //if the message says something about deleting then we ask them to refresh their browser
        var errstr = result.data;
        if (errstr.match("delete")) {
          alert(errstr + " - please refresh your browser");
        }
        else {
          alert(errstr);
		}  
        return;
      }
      //call an ajax poswered subroutine (no return value)
      dbFM.menuRename_pt2(obj);
    }
  });
}

//ok - we've established that we have appropriate permission to change the object, now we give them a textbox to type in their proposed new name
dbFM.menuRename_pt2 = function(obj) {
  //switch off tooltips
  if (dbFM.delayID != 0) {
    clearTimeout(dbFM.delayID);
    dbFM.delayID = 0;
  }
  dbFM.tooltips = false; 

  obj.is_file = ((obj.element.className != 'dirrow') && (obj.element.className.substring(0,4) != 'tree'));
  obj.renInput = dbFM.ce('input');
  obj.renInput.setAttribute('type', 'textfield');
  obj.renInput.value = obj.clickObj.firstChild.nodeValue;
  //clone input element since dbFM.contextMenuObj isn't destroyed on DOM
  obj.tempInput = obj.renInput.cloneNode(true);
  obj.tempInput.setAttribute('autocomplete','off'); //FF focus bug
  obj.clickparent = obj.clickObj.parentNode;
  obj.clickparent.replaceChild(obj.tempInput, obj.clickObj);
  //no change (blur) - restore original textNode
  var listener = dbFM.addEventListener(obj.tempInput, "blur", function (e) { dbFM.renameActive = false; obj.clickparent.replaceChild(obj.clickObj, obj.tempInput);dbFM.stopEvent(e);  });
  
  //listen for enter key - swap names (illegal names are ignored on server and next list
  //refresh will restore the proper filename)
  var listener = dbFM.addEventListener(obj.tempInput, "keydown", function(e) { if(dbFM.enter(e) && dbFM.renameActive == true){ dbFM.renameActive = false; dbFM.menuSwapname(obj); this.blur(); dbFM.stopEvent(e);} });
  setTimeout(function(){ obj.tempInput.focus();dbFM.renameActive = true; },10);
}

//new menu option - allows the selected file to be added to the list of attached files associated with a node. Note that files are not REALLY added to the 
//node attachments until the node itself is saved. Note that new files are added to the attachment list with a weighting one higher than the previous last entry
dbFM.menuAttach = function(obj) {

  var url = dbFM.ajaxUrl();
  var fid = obj.element.id.substr(3);

  //check that this file is not already attached
  var attach_arr = [];
  //strange construct - the problem here is that we're siting in the popup window, and the list is on the parent form - not currently in focus.
  attach_arr = parent.window.document.getElementById(dbFM.attachFormInput).value.split(','); 
  
  for(var i = 0; i < attach_arr.length; i++) {
     if(fid == attach_arr[i]) {
        alert("This file is already attached");
        break;
      }
  }
  
  //use ajax to return a set of data for the file we're interested in
  if(i == attach_arr.length) {
    var postObj = { action:encodeURIComponent("attachfile"), param0:encodeURIComponent(fid) };
    dbFM.HTTPPost(url, dbFM.ctxMenuAttachCallback, '', postObj);
  }
  // Close the dbfm window
  parent.GB_hide();
}

//new menu option - allows the selected file to be removed from the list of attached files associated with a node. Note that files are not REALLY removed from the 
//node attachments until the node itself is saved. All we actually do is remove the file from the attachment list for now
dbFM.menuDetach = function(obj) {
  //prompt to check they REALLY want to go ahead 
  if(dbFM.confirm("Remove attachment from node?")) {
    var fid = obj.element.id.substr(3);

    // update attachments table removing the selected file
    obj.element.parentNode.removeChild(obj.element);
    
    //remove the fid from the list of fids (this is how we are able to save the attachments when the node is saved
    var attach_arr = [];
    attach_arr = dbFM.$(dbFM.attachFormInput).value.split(',');
    var oneLess = '';
    var flag = true;
    for(var i = 0; i < attach_arr.length; i++) {
      if(attach_arr[i] != fid) {
        if (flag) {
          flag = false;
          oneLess += attach_arr[i];
        }
        else {
          oneLess += ',' + attach_arr[i];
		}        
      }
    }
    dbFM.$(dbFM.attachFormInput).value = oneLess;
  }
}


//the fuction swapname calls the server to actually make the change to the database
//the data passed has been changed - we now pass an id and the new name (no paths)
dbFM.menuSwapname = function(obj) {
  var url = dbFM.ajaxUrl();
  var fid = obj.element.id.substr(3);
  var thisType = obj.element.id.substr(0,3);

  //we're nearly done, re-enable the tooltips
  dbFM.tooltips = true;
  
  //now we need to find out what the object is - directories and files have different maximum lengths
  if (thisType == 'dir') 
    var maxlen = getMaxDname();
  else
    var maxlen = getMaxFname();

  if (obj.tempInput.value.length > maxlen) {
    alert("Name is excessively long (max " + maxlen + " chars)");
    return false;
  }
  dbFM.changeImage('refreshiconlist', 'rrevolve.gif'); //start the progress object spinning

  var postObj = { action:"rename", param0:encodeURIComponent(fid), param1:encodeURIComponent(obj.tempInput.value) };
  dbFM.HTTPPost(url, dbFM.ctx_callback, obj, postObj);
  return true;
}

dbFM.menuGetMeta = function(obj) {
  //we're now going to bring up and populate a popup
  //the element id is, for some bloody daft reason, prefixed by fid, for now I'm just going to have to strip off the fid
  var newurl;
  newurl = getBaseUrl() + '/dbfm_propertit/' + obj.element.id.substr(3);
  GB_show('File Manager: Properties', newurl, 480, 640,1);
}

dbFM.menuSub = function(obj) {
  //makes an AJAX call back to the server to either make a new entry in the susbcription table or delete an existing entry
  //rather than re-read the entire browser contents we'll just flip the sub entry for the curent object
  var fid = obj.element.id.substr(3);
  
  //test whether this object is already subscribed or not
  if (obj.sub)
    var todo = "&todo=unsubscribe"
  else
    var todo = "&todo=subscribe"
  
  //send an ajax call to the server to change the database removing the subscription row
  $.ajax({
    type: "POST",
    url: dbFM.ajaxUrl(),
    data: "action=subtoggle&fid=" + fid + todo,
    success: function(msg){
      //check the return value then, if everything worked, change the button appearance 
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        alert(result.data);   //result.data
        return;
      }
      //OK it worked - lets toggle the current object 
      if (obj.sub)
        obj.sub = false;
      else
	    obj.sub = true;  
    }
  });  // end of the ajax stuff  
}

//uses an AJAX call to the server to change a normal file entry into a version directory
//passes the file id of the initial file as a parameter
dbFM.menuVersion = function(obj) {

  var fid = obj.element.id.substr(3);
  var url = dbFM.ajaxUrl();

  //we need a permissions check to see they are entitled to make a version
  $.ajax({
    type: "POST",
    url: url,
    data: "action=permcheck&fid=" + fid,
    success: function(msg){
      //check the return values then call the function to actually make a directory (another ajax call)
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        alert(result.data);
        return;
      }
      //call an ajax poswered subroutine (no return value) to Create a new version file
      versionPt2(obj, url, fid);
    }
  });
}

function versionPt2(obj, url, fid) {
  //we need a prompt to double check they REALLY REALLY want to do this
  if (dbFM.confirm("Warning: Converting a file to a revision master is an irreversible process. Are you sure you want to proceed?")) {
    $.ajax({
      type: "POST",
      url: url,
      data: "action=makever&fid=" + fid,
      success: function(msg){
        //report the result
        var result = Drupal.parseJson(msg);
        if (result.status == false) {
          //output the returned error message before exiting
          alert(result.data);   //result.data
          return;
        }
        else {
          alert("A new version directory has been created");
          //having done that we should refresh the browser
          dbFM.dirListObj.refresh();
        }
      }     //end of callback function
    });   //end of ajax call
  }
}

//it seems we have a problem here because Charly doesn't like any speech widges in the title (they were put there because I was struggling with 
//names being truncated at the first space) so all the functions now need any widges stripped out
function widgeStrip(nameIn) {
  //if the name starts with a widge then strip it and assume it will also end with one
  var theLength = nameIn.length;
  if (nameIn.substring(0,1) == "'" || nameIn.substring(0,1) == '"') {
    return nameIn.substring(1, theLength-1);
  }
  return nameIn;
}

dbFM.menuLinkDir = function(obj) {
  var content = '';

  //build the content to be inserted into the node text - change made to display a meaningful image description
  content = "<a href='/dbfm" + obj.clickObj.name + "' alt=" + obj.clickObj.name + ">" + obj.clickObj.name + "</a>";
  dbfmToNodeText(content);
}

//note that obj.clickObj.textContent does NOT work in IE
dbFM.menuLink = function(obj) {
  var content = '';
  sendpath = getBaseUrl() + "/dbfm_send/" + obj.clickObj.title;

  //build the content to be inserted into the node text - change made to display a meaningful image description
//  content = "<a href='/dbfm_send/" + obj.clickObj.title + "' alt='" + obj.clickObj.name + "'>" + obj.clickObj.textContent + "</a>";
//  content = "<a href='" + sendpath + "' alt='" + obj.clickObj.name + "'>" + obj.clickObj.textContent + "</a>";
  content = "<a href='" + sendpath + "' alt=" + obj.clickObj.name + ">" + widgeStrip(obj.clickObj.name) + "</a>";
  dbfmToNodeText(content);
}

//note that obj.clickObj.textContent does NOT work in IE
dbFM.menuEmbed = function(obj) {
  var content = '';
  sendpath = getBaseUrl() + "/dbfm_send/" + obj.clickObj.title;

  //build the content to be inserted into the node text - change made to display a meaningful image description
  //need to prepend the base directory
//  content = "<img src='/dbfm_send/" + obj.clickObj.title + "' alt=" + obj.clickObj.name + " title=" + obj.clickObj.textContent + ">";
//  content = "<img src='" + sendpath + "' alt=" + obj.clickObj.name + " title=" + obj.clickObj.textContent + ">";
  content = "<img src='" + sendpath + "' alt=" + obj.clickObj.name + " title=" + widgeStrip(obj.clickObj.name) + ">";
  dbfmToNodeText(content);
}

dbFM.menuDownload = function(obj) {
  dbFM.selectFile(obj.element, true);
}

//open / display the version directory files
dbFM.menuVOpen = function(obj) {
  var fid = obj.element.id.substr(3);
  //works in the same fashion as clicking on a directory would, refreshes the browser with the version files listed
  dbFM.verdir = true;     //set a flag to indicate we're in a version directory
  //we disable the upload icon for as long as we're in the version directory
  
  //for IE opacity doesn't work  - instead they have something called filter with values from 0 to 100 ... but I couldn't even get that to work! 
  //I saw comments that indicated it only worked if you set the height and width of the element ... but even changing those didn't work for me
  //I needed a solution that worked in all cases so I actually switch out the image and flip it back when we leave the folder
  dbFM.changeImage('uploadIcon', 'folder_page_white_opaque.png');
  dbFM.changeImage('mkdirIcon', 'folder_add_opaque.png');
  dbFM.dirListObj.fetch(fid);
}

//delete the version directory and all the files within it (with a suitable warning!). The permissions check is done at the
//server end and now also includes a check to see whether the file is attached to any nodes
dbFM.menuVDel = function(obj) {
  var url = dbFM.ajaxUrl();
  //the id of a browser object has a 3 character prefix - e.g 'ver' + id - we need to strip this
  var fid = obj.element.id.substr(3);
  var path = obj.element.title;
  var chkMes = "Do you want to delete the version directory <" + path + "> and all its contents?";
  //now we know the fileID we need to check whether we have permission to delete this version directory
  $.ajax({
    type: "POST",
    url: url,
    data: "action=permatt&fid=" + fid + "&recur=true",
    success: function(msg){
      //check the return values then call the function to actually delete things
      var result = Drupal.parseJson(msg);
      if (result.status == false) {
        //output the returned error message before exiting
        alert(result.msg);
        return;
      }
      if (result.attach == true) {
        //one or more files within the version directory is attached to a node - change the warning message
        chkMes = result.data;
      }
      //prompt to check they REALLY want to go ahead 
      if(dbFM.confirm(chkMes)) {
//        dbFM.alrtObj.msg();  //clear the alert message - may get rid of these as Dennis prefers pop-ups
        dbFM.changeImage('refreshiconlist', 'rrevolve.gif'); //start the progress object spinning
        reallyDelete(url,obj, fid);
      }
    }
  });
}

//upload new file to the version directory - instead of just sending the file ID I append a "-1" to indicate that the upload is into a version
//directory
dbFM.menuVUpload = function(obj) {
  var fid = obj.element.id.substr(3) + "-1";
  GB_show('File Manager: Upload File',getBaseUrl() + '/dbfm_uploadit/' + fid,448,640,1);
}

//ZZZZZZZZZZdo I honestly still need this
dbFM.menuNoFidVal = function(obj) {
  //dbFM area files not in db have '0' click object title
  if (obj.element.id.substring(0,3) != 'fid')
    return true;
  return false;
}

dbFM.confirm = function(text) {
  var agree = confirm(text);
  return agree ? true : false;
}

//context menu callback function
dbFM.ctx_callback = function(string, xmlhttp, obj) {
  var retval = true;
  var saveCurrent = dbFM.current[1];

  dbFM.changeImage('refreshiconlist', 'r.gif'); //stop the progess indicator from spinning
//  dbFM.alrtObj.msg();  //clear any previous error message
    
  if (xmlhttp.status == 200) {
    var result = Drupal.parseJson(string);
    //refresh the filebrowser (or tree when you remove a directory)
    if (result.status) {
      // if the ajax returned something sensible
      //refresh the directory tree ONLY if we've done something like rename a directory BUT
      //having refreshed teh directory tree we need to get back to the last directory we were in
      if (obj.element.id.substring(0,3) == 'dir') {
        dbFM.dirTreeObj.fetch();
        //restore the current directory before refreshing the browser
//        dbFM.current[1] = saveCurrent;
      }
      //update the browser
      dbFM.current[1] = saveCurrent;
      dbFM.dirListObj.fetch(dbFM.current[1]);
    } 
    else if (result.data) {
      alert(result.data);
    } 
    else {
      alert("Operation fail");
      retval = false
    }
  } 
  else {
    alert(dbFM.js_msg["ajax-err"]);
    retval = false;
  }
  return retval;
}

// Trim leading/trailing whitespace off string
dbFM.trim = function(str) {
  return str.replace(/^\s+|\s+$/g, '');
}


/*
 * Attach constructor
 * the parent ID is the ID of the HTML form element to which the attach list is anchored (see hook_form_alter) - in our case it's dbfm-attach
 * this function just adds the header row - the actual row data is fetched using AJAX ... by the fetch
 */
dbFM.attach = function(parentId) {

  //should we check first whether there's anything to load before drawing the column headers??
  var wa = this;
  this.id = parentId
  this.attached = '';
  this.eventListeners = [];

  var elTable = dbFM.ce('table');
  var elTableBody = dbFM.ce('tbody');
  //attached file rows are appended to this div
  this.body = elTableBody;
  
  //we give the table an id to make attaching extra rows easier in the future
  elTableBody.setAttribute('id','tableBody');

  //Header
  var elTr = dbFM.ce('tr');

  // icon column
  var elTd = dbFM.ce('td');
  elTd.className = 'head';
  elTr.appendChild(elTd);

  // Sort files column
  var elTd = dbFM.ce('td');
  elTd.className = 'head';
  elTd.appendChild(dbFM.ctn(dbFM.js_msg["attach-title"]));
  elTr.appendChild(elTd);

  // date/time column
  var elTd = dbFM.ce('td');
  elTd.className = 'head';
  elTd.appendChild(dbFM.ctn(dbFM.js_msg["column2"]));
  elTr.appendChild(elTd);

  // file size column
  var elTd = dbFM.ce('td');
  elTd.className = 'head';
  elTd.appendChild(dbFM.ctn(dbFM.js_msg["column3"]));
  elTr.appendChild(elTd);

  elTableBody.appendChild(elTr);
  elTable.appendChild(elTableBody);
  dbFM.$(parentId).appendChild(elTable);
}

//the fetch uses AJAX to return a list of any files attached to this node
dbFM.attach.prototype.fetch = function() {
  var url = dbFM.ajaxUrl();
  // action attribute of node-edit form contains the node number
  var node_url = dbFM.$('node-form').action;
  var postObj = { action:encodeURIComponent("attach"), param0:encodeURIComponent(node_url) };
  dbFM.HTTPPost(url, this.callback, this, postObj);
}

//this routine deals with attachment data returned by the server from the AJAX call
dbFM.attach.prototype.callback = function(string, xmlhttp, obj) {
  att_menu = dbFM.menu.get('att');
  if (xmlhttp.status == 200) {
    result = Drupal.parseJson(string);
    if(result.status) {
      if(result.data.length) {
        var elInput = dbFM.$(dbFM.attachFormInput);
        for(var i = 0; i < result.data.length; i++) {
        
          //parameters are parent object (what we're glueing the row onto), fileobject (the row data), a base name for the row (which with a number - i - appended              //will become the row id), 
          //I'm not sure this is a good idea - perhaps we should have a specific dbFM.attachrow rather than use the filerow function. What happens if the user selects
          //a version? How do we deal with this 
          //the problem entry is the file menu one.
          var attrow = new dbFM.attachrow(obj.body, result.data[i], 'att', att_menu);
          //the 'value' property of the attachment list is set to a concatonation of all the file ID's - used to 
		  //check whether a file to be attached is already in the list
          elInput.setAttribute('value', (elInput.getAttribute('value')?elInput.getAttribute('value')+',':'') + result.data[i].id);        
        }
      }
    } 
	else {
	  //duff data returned from the ajax call
      alert("Invalid data returned by AJAX attach call: " + result.data);
    }
  } 
  else {
    //ajax call failed
    alert("AJAX attach call failed: " + dbFM.js_msg["ajax-err"]);
  }
}


/* This function builds a single row in the attach table (on the node screen)
 * I don't need the filepath or things like the image size - much simpler than a filerow
 * parameters are 
 * parent - the id of the object we're attaching this to
 * fileObj - the data (from the AJAX call) 
 *    id -> fid
 *    n -> file name 
 *    s -> file size
 *    m -> modified date
 *    icon -> filename of the icon to use
 * idtype - is the name given to this type of row (used to create the class)
 * index - a unique number to identify the position in the list 
 * file_menu - the context menu associated with this row type
 *
 */
 dbFM.attachrow = function(parent, fileObj, idtype, att_menu) {
  var ar = this;
  var flagit = false;
  ar.iconDir = getIconDir();
  var elTr = dbFM.ce('tr');
  ar.element = elTr;
  ar.fid = fileObj.id;
  ar.menu = att_menu;
  elTr.className = idtype + 'row';
  
  //check the parent is valid before bothering with anything else
  if (parent == null) {
    alert("Unable to attach file - invalid parent");
    return false;
  }
  
  // the fileObj ID (fid) should never be 0
  if (fileObj.id == 0) {
    alert("Invalid file data - Cannot add attachment");
    return false;
  }

  ar.row_id = idtype + fileObj.id;  // att + fid
  elTr.setAttribute('id', ar.row_id);

  //title of the attach row is its file ID
  elTr.setAttribute('title', fileObj.id);
  //attach object is always draggable
  ar.dd = new dbFM.draggable(elTr, elTr.className);

  //create the icon
  var elTd = dbFM.ce('td');
  var elImg = dbFM.ce('img');

  elImg.setAttribute('src', ar.iconDir + '/mime/' + fileObj.icon);
  elImg.setAttribute('alt', 'File');
  
  elTd.appendChild(elImg);
  elTd.setAttribute('class', 'cicon');

  elTr.appendChild(elTd);

  //sets the clickobj title to id if known 
  var elTd = dbFM.ce('td');
  ar.clickObj = dbFM.ce('a');

  //give it a unique ID
  ar.clickObj.setAttribute('id', fileObj.id);
  ar.clickObj.setAttribute('name', fileObj.n);
  ar.clickObj.setAttribute('href', '#');
  ar.clickObj.setAttribute('title', fileObj.id);
  
  //uses the filename here
  ar.clickObj.appendChild(dbFM.ctn(fileObj.n)); 
  elTd.appendChild(this.clickObj);
  elTd.setAttribute('class', 'cfname');

  elTr.appendChild(elTd);
  //strange this one - why a classname of txt??
  var elTd = dbFM.ce('td');
  elTd.className = 'txt';   //XXXXXXXXXXXXXXXXXXXXX
  elTd.appendChild(dbFM.ctn(fileObj.m));
  elTd.setAttribute('class', 'cfmod');
  elTr.appendChild(elTd);

  //and here too XXXXXXXXXXXXXXXXX
  var elTd = dbFM.ce('td');
  elTd.className = 'txt';
  var size = dbFM.size(fileObj.s);
  elTd.appendChild(dbFM.ctn(size));
  elTd.setAttribute('class', 'cfsize');
  elTr.appendChild(elTd);

  //mouse event listeners for an attach file row
  var listener = dbFM.addEventListener(ar.element, "mousedown", function(e) { dbFM.contextMenuObj.hideContextMenu(); ar.select(e); });

//NOT implementing a hover for the attach list - just a mousedown for select and drag/drop and a right button for context menu 
  // the event has to be saved in a 'global', dbFM.hEvent, since we need to know the mouse position when showing the tooltip hover-box 
//  var listener = dbFM.addEventListener(this.element, "mouseover", function(e) { dbFM.hEvent = Drupal.mousePosition(e); ar.hover(ar, true); });
//  var listener = dbFM.addEventListener(this.element, "mouseout", function(e) { ar.hover(ar, false); });
  
  //this runs whenever the RH mouse button is pressed
  var listener = dbFM.addEventListener(this.element, "contextmenu", function(e) { dbFM.contextMenuObj.showContextMenu(e, ar);dbFM.stopEvent(e); });

  //glue the table row we've just created onto the parent
  parent.appendChild(elTr);
  
  return true;
          
}

//this is what happens when they press a mouse button to select a row in the attachments list. 
dbFM.attachrow.prototype.select = function(event) {
  var cp = this;
  
  event = event || window.event;
  
  switch(event.target||event.srcElement) {
    case this.clickObj:
      // Determine mouse button - rightclick is only for the context menu, something else can deal with this
      var rightclick = dbFM.rclick(event);
      if (rightclick) {
        break;  //bring up the context menu
      }

     //to differentiate between a simple press and a drag we don't do anything for 300ms
      //if nothing else happens during the 300ms timeout 
      setTimeout(function(){
        //if we're not already dragging then selectfile
        if (dbFM.dragging == false) {
          //don't do a thing
//          dbFM.selectFile(cp.element);
        }
      },300);
      //passthrough
    default:
      //we're dragging it
      this.dd.mouseButton(event);
      break;
  }
  return false;
}

/**
 * dbFM.draggable constructor. This is called repeatedly when the filebrowser screen is built
 */
dbFM.draggable = function(element, _class) {
  this.element = element;
  //if the string starts with a slash then strip it off
  if (element.title.charAt(0) == '/') {
    this.curpath = element.title.substr(1);
  }
  else {
    this.curpath = element.title;
  }
  
  this.id = element.id;
  this.fid = element.fid;
  //a weird construct??
  this.isTree = _class.substring(0,4) == 'tree';
  this.isDir = (_class == 'dirrow') || this.isTree;
  this.isAttach = _class == 'attrow';  
  this.icondir = getIconDir();  
}

//entry point
dbFM.draggable.prototype.mouseButton = function(event) {
  event = event || window.event;

  // Determine mouse button - you can't drag with a rh button
  var rightclick = dbFM.rclick(event);
  if(!rightclick)
    this.beginDrag(event);
}

//next step after mouseButton
dbFM.draggable.prototype.beginDrag = function (event) {
  if (dbFM.dragging) {
    //we're already in the middle of a drag!
    return;
  }
  dbFM.dragging = true;
  var cp = this;
  //copy the existing mouse handler to somewhere safe before assigning the 
  //onmousemove event to our function handleDrag
  this.oldMoveHandler = document.onmousemove;
  document.onmousemove = function(e) { cp.handleDrag(e); };
  this.oldUpHandler = document.onmouseup;
  document.onmouseup = function(e) { cp.endDrag(e); };
  
  //prevent the tooltip box from being displayed during a drag
  if (dbFM.delayID != 0) {
    clearTimeout(dbFM.delayID);
    dbFM.delayID = 0;
  }

  if (this.isAttach == false) {
    //Lets store the scroll position of the directory list and the directory tree
    //these values will normally be zero unless we've got loadsa stuff on the page and need to scroll
    //ahah!! scrollTop doesn't work on Firefox because we're only ever scrolling the body
    if (dbFM.dlistID == "dirlist") {
      dbFM.ListY = dbFM.$(dbFM.dlistID + "body").scrollTop;
    }
    else {
      dbFM.ListY = dbFM.$(dbFM.dlistID).scrollTop;
    }
    dbFM.TreeY = dbFM.$("dirtree").scrollTop;
  }
  // Make slightly transparent
  this.element.style.opacity = 0.5;

  // Process
  this.handleDrag(event);
}

dbFM.draggable.prototype.handleDrag = function (event) {
  var off_scroll = 0; //the scroll offset to be applied to the tree and list elements

  //if we can't see the event, point to the window event
  event = event || window.event;

  //set up a couple of offset variables
  var eposX = 0;
  var eposY = 0;
  if (event.pageX || event.pageY) {
    eposX = event.pageX;
	eposY = event.pageY; 
  }
  else if (event.clientX || event.clientY) {
    eposX = event.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
    eposY = event.clientY + document.body.scrollTop + document.documentElement.scrollTop;
  }
  else {
    //This shouldn't ever happen
    eposX = event.x;
    eposY = event.y;
  }    
  
  //this is set by the calling program - why do we need this? how could it ever go wrong??
  if (!(dbFM.dragging)) {
    return;
  }
  
  var cp = this;

  //The dragStart flag ensures that the following executes once only at the
  //beginning of a drag-drop
  if (!(dbFM.dragStart)) {
    dbFM.dragStart = true;

    //put a copy of the dragged element into a drag container and make it visible
    this.offset = this.getObjectOffset(event, this.element);
 
    if(dbFM.browser.isIE && !this.isTree) {
      /* IE cannot clone table rows */
      var elDiv = dbFM.ce('div');
      elDiv.setAttribute('id', 'ieDragDiv');
      elDiv.appendChild(this.element.getElementsByTagName('img')[0].cloneNode(false));
      elDiv.appendChild(this.element.getElementsByTagName('a')[0].firstChild.cloneNode(false));
      dbFM.dragCont.appendChild(elDiv);
    } 
    else {
      dbFM.dragCont.appendChild(this.element.cloneNode(true));
    }

    dbFM.dragCont.style.display = 'block'
    dbFM.dragCont.style.zIndex = ++dbFM.zindex;

    //the tree stores everything without a leading slash, the browser listing shows everything WITH a slash
    //to compare the two we need to standardise - I'm choosing to access things WITHOUT the slash

    //Build dbFM.dropContainers array - knows where everything is on screen directory List and Tree
    //it's clever too! - elements that are invalid when dropping should NOT highlight
    //the path of the object we're dropping is in this.curpath EXCEPT for attachrows...
    dbFM.dropContainers = [];
    if (this.isAttach == false) {
      var curtemp = [];
      var droppath;
      curtemp = this.curpath.split('/');

      // Build list drop container array - note that we're only interested in directories - you can't drop something onto a file
      var dirListRows = dbFM.$(dbFM.dlistID).getElementsByTagName('tr');
      var dirListCont = [];
      var skip = false;
      var droptarget;
      var cont_pos;
      for(var k = 0; k < dirListRows.length; k++) {
        droptarget = dirListRows[k];
        skip = false;
        //only runs for entries in the tree
        if (droptarget.className == 'dirrow') {
          droppath = droptarget.title.substr(1);
          cont_pos = this.objPosition(droptarget);

          //lets decide whether it's a valid target 
        
          //drop onto ourself - a bad idea
          if (this.curpath == droppath) {
            continue;
          }

          //explode the path for the element we're considering dropping onto
          var droptemp = [];
          droptemp = droppath.split('/');
          // Test if drop path is beneath the drag path
          for(var j = 0; j < curtemp.length; j++) {
            if(curtemp[j] != droptemp[j])
              break;   
          }
          //if every element in the thing bring dragged matches the drop element then it's invalid for inclusion
          if (j == curtemp.length) {
            skip = true;
          } 
		  else {
            // Test if drop path is directly above drag path (already a subdir)
            for(var j = 0; j < droptemp.length; j++) {
              if(curtemp[j] != droptemp[j])
                break;
            }
            if ((j == droptemp.length) && (curtemp.length == j + 1))
              skip = true;
          }
          if (skip)
            continue;
        
          //the id is - as you'd hope - the file id
          var container = { id: droptarget.id, x: cont_pos.x, y: cont_pos.y - dbFM.ListY, w: droptarget.offsetWidth, h: droptarget.offsetHeight };
          dbFM.dropContainers.push(container);
        }
      }  //end of the for loop stepping through the directory rows

      //this is rather pointless - having made the id of the directory tree 'configurable' (a parameter passed to the tree constructor)
      //we now hard code it - ZZZZZZZ I'll recode defining it once at the top
      var dirTreeCont = '';
      dirTreeCont = dbFM.$("dirtree")
      if (dirTreeCont) {
        //reuse var for container list
        dirTreeCont = dbFM.$("dirtree").getElementsByTagName('li');
        if (dirTreeCont.length) {
          // Build tree drop container array
          for(var i = 0; i < dirTreeCont.length; i++) {
            // DragDrop element is folder icon
            droptarget = dirTreeCont[i].getElementsByTagName('div')[0];
            cont_pos = this.objPosition(droptarget);
            skip = false;

            //this stops invalid highlighting of drop areas 
            if(this.isTree) {
              // Prevent a directory drop onto itself or its direct parent (already a sub-directory)
              if((dirTreeCont[i] != this.element) && (dirTreeCont[i] != this.element.parentNode.parentNode)) {
                var children = this.element.getElementsByTagName('li');
                // Prevent a directory drop into a sub-directory
                for(var j = 0; j < children.length; j++) {
                  if(children[j] == dirTreeCont[i])
                    skip = true;
                }
              } 
              else {
                skip = true;
              }
            } 
            else {
              var droppath = dirTreeCont[i].title;
              if(this.curpath != droppath){
                droptemp = droppath.split('/');
                // Test if drop path is beneath the drag path
                for(var j = 0; j < curtemp.length; j++) {
                  if(curtemp[j] != droptemp[j])
                    break;
                }
                if(j == curtemp.length) {
                  skip = true;
                } 
			    else {
                  // Test if drop path is directly above drag path (already a subdir)
                  for(var j = 0; j < droptemp.length; j++) {
                    if(curtemp[j] != droptemp[j])
                      break;
                  }
                  if((j == droptemp.length) && (curtemp.length == j + 1))
                    skip = true;
                }
              } 
			  else {
                skip = true;
              }
            }
            if(skip == false) {
              // Valid drop container - add to array of drop containers
              var container = { id: dirTreeCont[i].id, x: cont_pos.x, y: cont_pos.y - dbFM.TreeY, w: droptarget.offsetWidth, h: droptarget.offsetHeight };
              dbFM.dropContainers.push(container);
            }
          } //end of for loop for tree drop container
        } // end of if treecont length
      }  //end of if tree
    }  //hmnn
  }
  else {
    //don't go here UNLESS we're playing with attach
    if (this.isAttach) {
      //code to deal with attach rows
      var droptarget = dbFM.attachObj.body;
      var cont_pos = this.objPosition(droptarget);
      dbFM.attachContainer = {x: cont_pos.x, y: cont_pos.y, w: droptarget.offsetWidth, h: droptarget.offsetHeight };
    }
  }

  // This code draws the dragging icons - we've scrapped the original drupal function - it goes in drupal 6 anyway - and  functions
  // now use the normal JS/DOM equivalent
  // apply the appropriate scroll offset testing first where we picked it up from
  // Ugghh! you can't apply the scroll offset here - apply it at the point you actually need it
  //off_scroll is your offset for the drag containers
  if (this.isTree) {
    //directory tree offset
    off_scroll = dbFM.TreeY;
  }
  else {
    //directory listing offset
    off_scroll = dbFM.ListY;
  }

  var x = eposX - this.offset.x;
  var y = eposY - this.offset.y;
 
  //Scroll page if we're near the top or bottom edge.  Hardcoded values. 
  var scroll = this.scroll();
  if(typeof(window.innerHeight) == 'number') {
    if(eposY > (window.innerHeight + scroll - 35)) {
      window.scrollBy(0,20);
    } else if(eposY  - scroll < (25)) {
      window.scrollBy(0,-20);
    }
  } else if(document.documentElement && document.documentElement.clientHeight) {
    if(eposY > (document.documentElement.clientHeight + scroll - 35)) {
      window.scrollBy(0,20);
    } else if(eposY  - scroll < (25)) {
      window.scrollBy(0,-20);
    }
  }

  // move our drag container to wherever the mouse is 
  dbFM.dragCont.style.left = x + 'px';
  dbFM.dragCont.style.top  = (y - off_scroll) + 'px';  //offset by the scroll position of where you're dragging it from

  if (!this.isAttach) {
    dbFM.activeCont = null;
    if(dbFM.dropContainers.length) {
      // Compare mouse position to every drop container
      for(var i = 0; i < dbFM.dropContainers.length; i++) {
        if((dbFM.dropContainers[i].x < eposX) &&
          (dbFM.dropContainers[i].y < eposY) &&
          ((dbFM.dropContainers[i].w + dbFM.dropContainers[i].x) > eposX) &&
          ((dbFM.dropContainers[i].h + dbFM.dropContainers[i].y) > eposY)) {
          // Found a valid drop container - Highlight selection (uses a red directory icon for something selected
          // otherwise we revert to the yellow one. 
          //ZZZZZ how are we going to represent this when we use the new icons? Guess we need 
          //to check what's there already and replace with the appropriate thing
            dbFM.activeCont = dbFM.$(dbFM.dropContainers[i].id);
            dbFM.$(dbFM.dropContainers[i].id + 'dd').src = this.icondir + '/open.gif';
            dbFM.$(dbFM.dropContainers[i].id).className += '_selected';
        } 
        else {
          // De-highlight container
          dbFM.$(dbFM.dropContainers[i].id + 'dd').src = this.icondir + '/d.gif';
          var class_names = [];
          class_names = dbFM.$(dbFM.dropContainers[i].id).className.split(' ');
          dbFM.$(dbFM.dropContainers[i].id).className = class_names[0];
        }
      }
    }
  }
  else {
    //ignore all movement outside the attach list
    if ((dbFM.attachContainer.x < x) && 
      (dbFM.attachContainer.y < y) &&
      ((dbFM.attachContainer.w + dbFM.attachContainer.x) > x) &&
      ((dbFM.attachContainer.h + dbFM.attachContainer.y) > y)) {
        var att_table_body = dbFM.attachObj.body;
        var attachRows = att_table_body.getElementsByTagName('TR');
        var prevNode = '';
        var nextNode = '';
        var curr = false;
        //start at 1 since the first row in the list is the header row
        for (var i = 1;i < attachRows.length; i++) {
          if (this.element.id != attachRows[i].id) {
            //ZZZZZZZZZZZZZZZZ
            var att_pos = this.objPosition(attachRows[i]);
            if ((att_pos.y + (attachRows[i].offsetHeight / 2)) < y) {
              if (curr == true) 
                prevNode = attachRows[i];
            }
            else if ((att_pos.y + (attachRows[i].offsetHeight / 2)) > y) {
              if (curr == false)
                nextNode = attachRows[i];                  
            }
          }
          else {
            curr = true;
          }
        } //end of for loop
        
        //now we try to shove the dragged entry into the table in its new position
        try {
          if (prevNode) {
            att_table_body.insertBefore(prevNode, this.element);
          }
          else if (nextNode) {
	        att_table_body.insertBefore(this.element, nextNode); 
		  }
		}
		catch(err) {
		  alert("Error moving entry in list " + err);
		}  
    }
  }
  //prevent selection of textnodes
  dbFM.stopEvent(event);

}

dbFM.draggable.prototype.endDrag = function (event) {
  if (!(dbFM.dragging)) {
    return;
  }
  event = event || window.event;

  // Uncapture mouse
  document.onmousemove = this.oldMoveHandler;
  document.onmouseup = this.oldUpHandler;

  // We remove anything that is in our drag container.
  dbFM.clearNodeById('dragCont');

  // Restore opacity
  this.element.style.opacity = 1.0;
  dbFM.dragging = false;
  dbFM.dragStart = false;
  dbFM.dragCont.style.display = 'none';
  dbFM.stopEvent(event);

  //we need to deal with attach objects in a different way from anything else
  if (!this.isAttach) {
    // Move dragged object if a valid drop container
    if(dbFM.activeCont) {
      this.droppath = dbFM.activeCont.title;

      if (dbFM.activeCont.id.match('dirtree') == null) {
        this.dropfid = dbFM.activeCont.id.substr(3);
      } 
      else {
        this.dropfid = dbFM.$(dbFM.activeCont.id + 'xx').title;
      }
      if (this.element.id.match('dirtree') == null) {
        this.dragfid = this.element.id.substr(3);
      }
      else {
        this.dragfid = dbFM.$(this.element.id + 'xx').title;
      }
      // De-highlight container
      dbFM.$(dbFM.activeCont.id + 'dd').src = this.icondir + '/d.gif';
      var class_names = [];
      class_names = dbFM.activeCont.className.split(' ');
      dbFM.activeCont.className = class_names[0];
      //prompt before we go any further
      if (confirm("Are you sure you want to move <" + this.curpath + "> to <" + this.droppath + "> ?")) {
        //now we need to find the source and destination fids - what we have are the element ids of the source and destination
        var url = dbFM.ajaxUrl();
        dbFM.changeImage('refreshiconlist', 'rrevolve.gif');
        var postObj = { action:"move", param0:encodeURIComponent(this.dragfid), param1:encodeURIComponent(this.dropfid) };
        dbFM.HTTPPost(url, this.callback, this, postObj);
      }
      dbFM.activeCont = null;
    }
  }
  else {
    //code to deal with attachments - note that changes are not copied back to the database until the node is saved
    var elInput = dbFM.$(dbFM.attachFormInput);
    var attachRows = dbFM.attachObj.body.getElementsByTagName('tr');
    elInput.setAttribute('value','');
    //1st row in list is always the header
    for (var i = 1; i < attachRows.length; i++) {
      var fid = attachRows[i].id.substring(3);   //not sure about this - have I got a 3 character prefix on the ID???
      //ughhhh!!!
      elInput.setAttribute('value',(elInput.getAttribute('value') ? elInput.getAttribute('value') + ',' : '') + fid);
    }     
  }
}

dbFM.draggable.prototype.callback = function(string, xmlhttp, cp) {
  dbFM.changeImage('refreshiconlist', 'r.gif');
//  dbFM.alrtObj.msg();
  if(xmlhttp.status == 200) {
    var result = Drupal.parseJson(string);
    if(result.status) {
      if(cp.isDir)
        dbFM.dirTreeObj.fetch();
      if(!cp.isTree)
        //listing draggable - update current listing by removing dropped item - how did this ever work before
        cp.element.parentNode.removeChild(cp.element);
      else {
        //tree draggable - update target directory
        dbFM.verdir = false;   //reset the flag to indicate we're not looking at a version directory
        dbFM.changeImage("uploadIcon", "folder_page_white.png");
        dbFM.changeImage("mkdirIcon", "folder_add.png");
        dbFM.dirListObj.fetch(cp.dropfid);
      }
    } 
    else {
      //an error has occurred
      if (result.data) {
        alert(result.data);
      }
      else {
        alert(dbFM.js_msg["move-err"]);
      }
    }
  } 
  else {
//    dbFM.alrtObj.msg(dbFM.js_msg["ajax-err"]);
    alert(dbFM.js_msg["ajax-err"]);
  }
}

//returns a y offset if the window as a whole has scrolled DOES THE pageY offset work in IE?
dbFM.draggable.prototype.scroll = function () {
  var scrY = 0;
  if(typeof(window.pageYOffset) == 'number') {
    scrY = window.pageYOffset;
  } 
  else if(document.body && document.body.scrollTop) {
    scrY = document.body.scrollTop;
  } 
  else if(document.documentElement && document.documentElement.scrollTop) {
    scrY = document.documentElement.scrollTop;
  }
  return scrY;
}

//changed to get rid of the Drupal mouse function - now revised because it 
//didn't work with IE
dbFM.draggable.prototype.getObjectOffset = function(event, element) {
  var objPos = this.objPosition(element);
  //if we're NOT dealing with IE then use the page property - otherwise we need to frig with the 
  //client property
  var posX = 0;
  var posY = 0;
  if (event.pageX || event.pageY) {
    posX = event.pageX;
	posY = event.pageY; 
  }
  else if (event.clientX || event.clientY) {
    posX = event.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
    posY = event.clientY + document.body.scrollTop + document.documentElement.scrollTop;
  }
  else {
    //This shouldn't ever happen
    posX = event.x;
    posY = event.y;
  }    
  return {x:posX - objPos.x, y:posY - objPos.y};
}

//returns the x and y positions of the element passed (complete with a fiddle factor for IE
dbFM.draggable.prototype.objPosition = function(element) {
  var curleft = curtop = 0;
  if(element.offsetParent) {
    curleft = element.offsetLeft;
    curtop = element.offsetTop;
    while(element = element.offsetParent) {
      curleft += element.offsetLeft;
      curtop += element.offsetTop;
    }
  }
  /* IE must compensate for relative positioning in css - sorry about the magic numbers */
  //if(dbFM.browser.isIE) {
  //  curleft -= 20;    //originally 205
  //  if(this.isTree)
  //    curleft -= 20;
  //}
  return { x:curleft, y:curtop };
}

/**
 * Event Handler from http://ajaxcookbook.org (Creative Commons Attribution 2.5)
 */
dbFM.addEventListener = function(instance, eventName, listener) {
    var listenerFn = listener;
    if (instance.addEventListener) {
        instance.addEventListener(eventName, listenerFn, false);
    } else if (instance.attachEvent) {
        listenerFn = function() {
            listener(window.event);
        }
        instance.attachEvent("on" + eventName, listenerFn);
    } else {
        throw new Error("Event registration not supported");
    }
    var event = {
        instance: instance,
        name: eventName,
        listener: listenerFn
    };
    dbFM.eventListeners.push(event);
    return event;
}

dbFM.removeEventListener = function(event) {
    var instance = event.instance;
    if (instance.removeEventListener) {
        instance.removeEventListener(event.name, event.listener, false);
    } else if (instance.detachEvent) {
        instance.detachEvent("on" + event.name, event.listener);
    }
    for (var i = 0; i < dbFM.eventListeners.length; i++) {
      if (dbFM.eventListeners[i] == event) {
        dbFM.eventListeners.splice(i, 1);
        break;
      }
    }
}

//is there a problem here? Ahah! aparently I have to edit template.php because this
//doesn't clear up properly
dbFM.unregisterAllEvents = function() {
  while (dbFM.eventListeners.length > 0) {
    dbFM.removeEventListener(dbFM.eventListeners[0]);
  }
  dbFM.eventListeners = [];
}

/**
 * Helper Functions
 */
 //return the element id
dbFM.$ = function(id) { return document.getElementById(id); }
//create a text node
dbFM.ctn = function(textNodeContents) { var textNode = document.createTextNode(textNodeContents); return textNode; }
//create an element
dbFM.ce = function(elementName) { elementName = elementName.toLowerCase(); var element = document.createElement(elementName); return element; }

/**
 * Creates an HTTP POST request and sends the response to the callback function
 *
 * Note: passing null or undefined for 'object' makes the request fail in Opera 8.
 *       Pass an empty string instead.
 */
dbFM.HTTPPost = function(uri, callbackFunction, callbackParameter, object) {
  var xmlHttp = new XMLHttpRequest();
  var bAsync = true;
  if (!callbackFunction) {
    bAsync = false;
  }
  xmlHttp.open('POST', uri, bAsync);

  var toSend = '';
  if (typeof object == 'object') {
    xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    for (var i in object) {
      toSend += (toSend ? '&' : '') + i + '=' + encodeURIComponent(object[i]);
    }
  }
  else {
    toSend = object;
  }
  
  xmlHttp.send(toSend);

  if (bAsync) {
    xmlHttp.onreadystatechange = function() {
      if (xmlHttp.readyState == 4) {
        callbackFunction(xmlHttp.responseText, xmlHttp, callbackParameter);
      }
    }
    return xmlHttp;
  }
  else {
    return xmlHttp.responseText;
  }
}

/**
 * Prevents an event from propagating.
 */
dbFM.stopEvent = function(event) {
//alert("Reached stop event");
  if (event.preventDefault) {
    event.preventDefault();
    event.stopPropagation();
  }
  else {
    event.returnValue = false;
    event.cancelBubble = true;
  }
}

/**
 * Maintain compatibility with collapse.js
 * Since dbfm fieldsets are built directly on the DOM, collapse.js onload
 * event will not convert them automatically - we must invoke manually here
 * dontya just hate spaces in classnames??
 */
dbFM.collapseFSet = function(parent, text, collapse) {
  parent.className = 'collapsible collapsed';
  var elLegend = dbFM.ce('legend');
  parent.appendChild(elLegend);
  var fieldset = parent;
  // Expand if there are errors inside
  if (($('input.error, textarea.error, select.error', fieldset).size() > 0) || collapse) {
    parent.className = 'collapsible';
  }

  // Turn the legend into a clickable link and wrap the contents of the fieldset
  // in a div for easier animation
  $(elLegend).empty().append($('<a href="#">'+ text +'</a>').click(function() {
    var fieldset = $(elLegend).parents('fieldset:first')[0];
    // Don't animate multiple times
    if (!fieldset.animating) {
      fieldset.animating = true;
      Drupal.toggleFieldset(fieldset);
    }
    return false;
  }));
}

//the getModUrl() is used by contrib modules for custom ajax
dbFM.ajaxUrl = function() {
  var path = getBaseUrl() + "/?q=";
  return path += (typeof getModUrl == "undefined") ? "dbfm_js" : getModUrl();
}

// Empty all child nodes
dbFM.clearNodeById = function(elementId) {
  var node = dbFM.$(elementId);
  while (node.hasChildNodes())
    node.removeChild(node.firstChild);
}

dbFM.sortByName = function(a, b) {
  var x = a.n.toLowerCase();
  var y = b.n.toLowerCase();
  return ((x < y) ? -1 : ((x > y) ? 1 : 0));
}
dbFM.sortBySize = function(a, b) {
  var x = parseInt(parseFloat(a.s));
  var y = parseInt(parseFloat(b.s));
  return x - y;
}
dbFM.sortByModified = function(a, b) {
  var x = a.m;
  var y = b.m;
  return ((x < y) ? -1 : ((x > y) ? 1 : 0));
}
dbFM.sortByKey = function(a, b) {
  var x = a.toLowerCase();
  var y = b.toLowerCase();
  return ((x < y) ? -1 : ((x > y) ? 1 : 0));
}

dbFM.size = function(sz) {
  var size = sz;
  var units;
  if(size < 1024) units = " B";
  else {
    size = parseInt(size >> 10);
    if(size < 1024) units = " KB";
    else {
      size = parseInt(size >> 10);
      if(size < 1024) units = " MB";
      else {
        size = parseInt(size >> 10);
        if(size < 1024) units = " GB";
        else {
          size = parseInt(size >> 10);
          suffix = " TB";
        }
      }
    }
  }
  return size + units;
}
//how does this work? where's e coming from??
dbFM.enter = function(event) {
  event = event || window.event;
  var code;
  if (event.keyCode)
    code = event.keyCode;
  else if (e.which)
    code = e.which;
  return(code == 13) ? true : false;
}


dbFM.rclick= function(event) {
  if (event.which) {
    var rightclick = (event.which == 3);
  } else {
    if (event.button)
      var rightclick = (event.button == 2);
  }
  return rightclick;
}


// Naive way to tell an array from an object:
// it is an array if it has a defined length
dbFM.isArray = function(thing) {
  if (typeof(thing) != 'object') return false;
  if (typeof(thing.length) == 'undefined') return false;
  return true;
}

// Naive way to tell an array from an object:
// it is an array if it has a defined length
dbFM.isObject = function(thing) {
  if (typeof(thing) != 'object') return false;
  if (typeof(thing.length) != 'undefined') return false;
  return true;
}


// this bungs a chunk of HTML into the node editor window 
function dbfmToNodeText(content) {
  //test here for the presence of the tiny editor to determine whether we put 
  //the text straight into the text area
  var element = this.parent.window.document.getElementById('edit-body');
  var runningTiny = false;

  //this test doesn't always work as it should. Perhaps it's easier to assume we're NOT running Tiny
  //it might be beter to test in PHP and pass the value in when we open the page - nope, that can't work
  //we can test whether Tiny is present but not whether it's in use on the node the user is editing is another matter
  try {
    if (this.parent.tinyMCE.getEditorId(element.id) != null) {
      runningTiny = true;
    }
  }
  catch(err) {
    //don't actually need this but I gotta put something in the catch
    runningTiny = false;
  } 
  
  if (runningTiny) {
    this.parent.tinyMCE.execCommand("mceInsertContent", true, content);
    this.parent.tinyMCE.selectedInstance.repaint();
    // Close the dbfm window
    this.parent.GB_hide();
    return false;
  }
  else {
    var textarea = dbFM.$('edit-body');
    var myDoc = window.document;
    var cursor;

    //test whether the textarea is on the current page or back on the parent 'opener' page (for popups)
    if (!(textarea)) {
      //the $ method didn't get it so
      textarea = this.parent.window.dbFM.$('edit-body');
      if (!(textarea)) {
        alert("An error has occurred - file cannot be linked / embedded");
        return;
      }
    }
    if (myDoc.selection) {
      textarea.focus();
      cursor = myDoc.selection.createRange();
      cursor.text = content;
    } 
    else if (textarea.selectionStart || textarea.selectionStart == "0") { /* Gecko-based engines: Mozilla, Camino, Firefox, Netscape, Iceweasel */
      var startPos  = textarea.selectionStart;
      var endPos    = textarea.selectionEnd;
      var body      = textarea.value;
      textarea.value = body.substring(0, startPos) + content + body.substring(endPos, body.length);
    } 
    else { /* Worst case scenario: browsers that don't know about cursor position, Safari, OmniWeb, Konqueror */
      textarea.value +=content;  //this just adds the text at the end rather than inserting it at the cursor position
    }
    //we've done it, now close the browser overlay window
    this.parent.GB_hide();
  }
  //doesn't matter what we return
  return false;
}

/////////////////////////////////////////////////////////////////////////
///////////////extra functions added for the popup boxes ////////////////
/////////////////////////////////////////////////////////////////////////

// I don't need even a fraction of this! have to have a prune soon!

var currentMode;


function updateCaption() {
  var caption = frames['dbfm_main'].dbFM.$("caption");
  var title = frames['dbfm_main'].document.dbfm['edit-title'].value;
  var desc = frames['dbfm_main'].document.dbfm['edit-desc'].value;
  if (desc != '') {
    title = title + ': ';
  }
  caption.innerHTML = '<strong>' + title + '</strong>' + desc;
}

function onChangeHeight() {
  var formObj = frames['dbfm_main'].document.forms[0];
  var aspect = formObj['edit-aspect'].value;
  var height = formObj['edit-height'].value;
  formObj['edit-width'].value = Math.round(height * aspect);
}

function onChangeWidth() {
  var formObj = frames['dbfm_main'].document.forms[0];
  var aspect = formObj['edit-aspect'].value;
  var width = formObj['edit-width'].value;
  formObj['edit-height'].value = Math.round(width / aspect);
}

function onChangeLink() {
  var formObj = frames['dbfm_main'].document.forms[0];
  if (formObj['edit-link-options-visible'].value == 1) {
    if (formObj['edit-link'].value == 'url') {
      showElement('edit-url', 'inline');
    } 
    else {
      hideElement('edit-url');
    }
  }
}

function onChangeSizeLabel() {
  var formObj = frames['dbfm_main'].document.forms[0];
  if (formObj['edit-size-label'].value == 'other') {
    showElement('size-other', 'inline');
  } else {
    hideElement('size-other');
    //showElement('size-other', 'inline'); // uncomment for testing
    // get the new width and height
    var size = formObj['edit-size-label'].value.split('x');
    // this array is probably a bounding box size, not an actual image
    // size, so now we use the known aspect ratio to find the actual size
    var aspect = formObj['edit-aspect'].value;
    var width = size[0];
    var height = size[1];
    if (Math.round(width / aspect) <= height) { // width is controlling factor
      height = Math.round(width / aspect);
    } else { // height is controlling factor
      width = Math.round(height * aspect);
    }
    // fill the hidden width and height textboxes with these values
    formObj['edit-width'].value = width;
    formObj['edit-height'].value = height;
  }
}

//not sure about this - why does it need a global? can you do static in javascript?? No, you DO need a global.
function setHeader(mode) {
  if (currentMode != mode) {
    frames['dbfm_header'].window.location.href = BASE_URL + 'index.php?q=dbfm/header/' + mode;
  }
  currentMode = mode;
}

function showElement(id, format) {
  var docObj = frames['dbfm_main'].document;
  format = (format) ? format : 'block';
  if (docObj.layers) {
    docObj.layers[id].display = format;
  } else if (docObj.all) {
    docObj.all[id].style.display = format;
  } else if (docObj.getElementById) {
    docObj.getElementById(id).style.display = format;
  }
}

function hideElement(id) {
  var docObj = frames['dbfm_main'].document;
  if (docObj.layers) {
    docObj.layers[id].display = 'none';
  } else if (docObj.all) {
    docObj.all[id].style.display = 'none';
  } else if (docObj.getElementById) {
    docObj.getElementById(id).style.display = 'none';
  }
}

//This uses window opener - nicked from Andres code
function insertImage() {
  if (window.opener) {
    // Get variables from the fields on the properties frame
    var formObj = frames['dbfm_main'].document.forms[0];
    // Get mode	(see dbfm.module for detailed comments)
    if (formObj['edit-insertmode'].value == 'html') { // return so the page can submit normally and generate the HTML code
      return true;
    }
    else if (formObj['edit-insertmode'].value == 'html2') { 
      // HTML step 2 (processed code, ready to be inserted)
      var content = getHTML(formObj);
    }
    else {
      //this is the REAL thing, generates a drupal filter tag
      var content = getFilterTag(formObj);
    }
    insertToEditor(content);
    return false;
  } 
  else {
    alert('The image cannot be inserted because the parent window cannot be found.');
    return false;
  }
}

//called by the icon on the node form to display a greybox overlay window
//I've now added 2 extra parameters so that the boxes can be different sizes
function popit(url, gwidth, gheight) {
  if (gwidth == null) gwidth = 750;
  if (gheight == null) gheight = 580;
  GB_show('dB File Manager', url, gwidth, gheight,0);
  return false;
}

function getHTML(formObj) {
  var html = frames['dbfm_main'].dbFM.$("finalhtmlcode").innerHTML;
  return html;
}

//just adds a spacer element - a div
dbFM.spacer = function(parent,id) {
  this.id = id;
  var elDiv = dbFM.ce('div');
  elDiv.setAttribute('id', this.id);
  elDiv.className = 'spacer';

  progImg = document.createElement('img');
  progImg.setAttribute('src', getIconDir()+ '/spacer.png');
  progImg.setAttribute('width', '0px');
  progImg.setAttribute('height', '0px');
  elDiv.appendChild(progImg);
  parent.appendChild(elDiv);
}


//this function will either return a valid directory name or the fact that the user's cancelled
//entering a blank string is equivalent to pressing cancel
function mkdir_prompt()
{
  //note that we can't test here to see whether the directory name is unique - that's still done at the server end
  var name=prompt("Enter the directory name: ","New_Folder");
  if (name==null)
    name = "";
  return (name);
}

// Function to create a new directory - 1st parameter is now the fid
function callmkdir(pfid, url, newdirname, myobj ) {

  //make the second ajax call
  dbFM.changeImage('refreshiconlist', 'rrevolve.gif');
  var postObj = { action:"mkdir", param0:encodeURIComponent(pfid), param1:newdirname };
  dbFM.HTTPPost(url, mkdir_callbackf, myobj, postObj);
}

/**
 *  menu callback to attach a dbfm file to a node
 */
dbFM.ctxMenuAttachCallback = function(string, xmlhttp, cp) {
  att_menu = dbFM.menu.get('att');

  if (xmlhttp.status == 200) {
    var result = Drupal.parseJson(string);
    //the ajax call should return a single file entry. We need to add this to our list and adjust the 'value' of the parent
    if (result.status) {
      //give them a warning if the file they are attaching hasn't got universal read access
      if (result.access == false) {
        if(!dbFM.confirm("The attachment will not be accessable to all users unless you change its read access to public. Continue?"))
		  return;
	  }  
		 
      //we have a problem here - we're in the popup iframe, we're trying to add something to the underlying screen
      //have to make sure we get the parent right     
      var elInput = parent.window.document.getElementById(dbFM.attachFormInput);
      attObj = parent.window.document.getElementById("tableBody");
      var attret = new dbFM.attachrow(attObj, result.data, 'att', att_menu);
      //append the fid to the value of the parent object - no need to print a message on error, the attachrow function does its own reporting
      elInput.setAttribute('value', (elInput.getAttribute('value')?elInput.getAttribute('value')+',':'') + result.data.id);
    } 
	else
      alert("Invalid data returned by AJAX attach call: " + result.data);
  } 
  else {
    alert("AJAX attach call failed: " + dbFM.js_msg["ajax-err"]);
  }
}

//refreshes the tree and browser after making a new directory
function mkdir_callbackf(string, xmlhttp, cp) {
  var saveCurrent = dbFM.current[1];

  dbFM.changeImage('refreshiconlist', 'r.gif');
  if (xmlhttp.status == 200) {
    var result = Drupal.parseJson(string);

    if(result.status == false) {
      alert(dbFM.js_msg["mkdir-err"] + " - " + result.data);
      return;
    }
    //it worked - lets refresh both tree and browser
    dbFM.dirTreeObj.fetch();
    //restore the correct fid (otherwise we end up back in the root directory) and refresh the browser
    dbFM.current[1] = saveCurrent;
    dbFM.dirListObj.fetch(dbFM.current[1]);
  } 
  else {
    alert(dbFM.js_msg["ajax-err"]);
  }
}

//timing function to refresh the browser - the delay is passed through from the PHP code (it's set up on the admin screen) 
//using a function. The parameter is just there to indicate whether this is the first time through
function dbfm_browser_ref(first_time) {
  var s;
  var lr;
	
  //the value returned by getRefresh may be 0, in which case we don't periodically refresh the browser or it may be a value in secords which we need 
  //to multiply by 1000 to convert to milliseconds
  var thedelay = getRefresh() * 1000;
  if (thedelay == 0)
    return;
    
  //call the server to ask them whether we need to refresh the browser - if so, do it!
  //we don't run this test if the user is currently on a subscreen (eg already uploading)
  if (!first_time || dbFM.popup) {
    //now uses JQuery to call the server and check whether a refresh is needed
    var pfid = dbFM.current[1];
    $.ajax({
      type: "POST",
      url: dbFM.ajaxUrl(),
      data: "action=refreshme",
      success: function(msg){
        //check the return values 
        var result = Drupal.parseJson(msg);
      
        if (result.status) {
          //prompt for the new directory name
          if (result.data == 11) {
            //refreshing anything actually involves another ajax call - kinda nested ajax!   
            //problem - refreshing the tree always trashes the settings for the context menu
            dbFM.dirTreeObj.fetch();
            dbFM.dirListObj.fetch();
          }
          else {
           dbFM.dirListObj.fetch();
          }
        }
      }
    });  
  }
	  
  //we don't really need s - it's only point is if you needed it to cancel a timeout	  
  s = setTimeout ("dbfm_browser_ref(false)", thedelay);
  return;  
}
